package dascosa.algebra;

import dascosa.data.*;
import dascosa.site.query.Executor;

import javax.sql.DataSource;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 25.apr.2007
 * Time: 15:09:40
 * To change this template use File | Settings | File Templates.
 */
public final class DisplayNode extends AlgebraNode
{
  public DisplayNode()
  {
    super(new AlgebraNode[0]);
  }

  public String toString()
  {
    return "DisplayResult()";
  }

  public boolean doOperation(Executor executor, DataSource dataSource)
  {
    throw new RuntimeException("Do not call doOperation() on DisplayNodes");
  }

  public double getCostEstimate()
  {
    double cost = 0.0;

    for (AlgebraNode n : getOperandNodes()) {
      cost += n.getCostEstimate();
    }

    return cost;
  }

  public FinalResult getFinalResult()
  {
    FinalResult finalResult = new FinalResult(operands[0]);
    operands = null;
    return finalResult;
  }

  public double getSizeEstimate()
  {
    double size = 0.0;

    for (AlgebraNode n : getOperandNodes()) {
      size += n.getSizeEstimate();
    }

    return size;
  }

  public boolean isComplete()
  {
    return operands != null && operands[0] != null && operands[0].isComplete();
  }

  public PartialResult simulate()
  {
    if (operands == null)
      return null;
    PartialResult simulation = new PartialResult(1);
    PacketHeader resultPart = new PacketHeader(operands[0], getOperationID(), getNodeID(),
                                               -1);
    simulation.addPacketHeader(null, resultPart);

    operands = null;
    return simulation;
  }
//  @Override
//  public boolean isPJS(){
//    for (AlgebraNode node : getOperandNodes())
//      if (!node.isPJS())
//        return false;
//    return true;
//  }
}
