package dascosa.algebra;

import dascosa.data.*;
import dascosa.site.query.Executor;

import javax.sql.DataSource;
import java.util.*;

/**
 * @deprecated
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 02.mai.2007
 * Time: 15:16:15
 * To change this template use File | Settings | File Templates.
 */
public final class ProjectNode extends AlgebraNode implements PartialRestartable, Pauseable
{
  private final String attributeNames[];

  /**
   * @deprecated Use ExtendedProjectNode(AlgebraNode, String[]) instead
   */
  public ProjectNode(AlgebraNode resultNode, String attributeNames[])
  {
    super(resultNode);
    this.attributeNames = attributeNames;
  }

  public String toString()
  {
    return "Project(" + Arrays.toString(attributeNames) + ')';
  }

  public boolean doOperation(Executor executor, DataSource dataSource)
  {
    if (operands == null)
      return false;
    PacketHeader resultHeader;
    if (result == null) {
      List<String> newColumns = new ArrayList<String>();
      for (String attribute : attributeNames)
        if (operands[0].getColumn(attribute) != -1)
          newColumns.add(attribute);

      result = new PartialResult(1, startTags);
      resultHeader = new PacketHeader(newColumns, getOperationID(), getNodeID(), getResultNodeID(0));
      result.addPacketHeader(executor, resultHeader);
    }
    else
      resultHeader = result.getPacketHeader(0);

    boolean pauseProduction = false;
    PacketIterator iterator = operands[0].unprocessedIterator();
    while (!pauseProduction && iterator.hasNext()) {
      Object resultTuple[] = new Object[resultHeader.getColumnCount()];
      Object operandTuple[] = iterator.next();
      for (int i = 0; i < resultTuple.length; i++)
        resultTuple[i] = operandTuple[operands[0].getColumn(result.getColumnName(i))];
      pauseProduction = result.addTuple(executor, resultHeader, resultTuple);
    }

    if (operands[0].isComplete() && !operands[0].hasUnprocessedPackets() && !iterator.hasNext()) {
      result.lastTupleAdded(executor, resultHeader);
      return false;
    }
    else
      return pauseProduction;
  }

  public double getCostEstimate()
  {
    double cost = 0.0;
    double size = 0.0;

    for (AlgebraNode n : getOperandNodes()) {
      cost += n.getCostEstimate();
      size += n.getSizeEstimate();
    }
    cost += size;

    return cost;
  }

  public double getSizeEstimate()
  {
    double size = 0.0;

    for (AlgebraNode n : getOperandNodes()) {
      size += n.getSizeEstimate();
    }
    // TODO: Write code that actually works, in stead of:
    //size /= getOperandNodes().get(0).getResult().getColumnCount();
    //size *= result.getColumnCount();
    size *= 0.1;

    return size;
  }

  public PartialResult simulate()
  {
    if (operands == null)
      return null;
    List<String> newColumns = new ArrayList<String>();
    for (String attribute : attributeNames)
      if (operands[0].getColumn(attribute) != -1)
        newColumns.add(attribute);

    PartialResult simulation = new PartialResult(1);
    PacketHeader resultPart = new PacketHeader(newColumns, getOperationID(), getNodeID(),
                                               getResultNodeID(0));
    simulation.addPacketHeader(null, resultPart);
    operands = null;

    return simulation;
  }
}
