package dascosa.algebra.function;

import dascosa.data.Operand;

import java.io.Serializable;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 18.feb.2008
 * Time: 16:05:19
 * To change this template use File | Settings | File Templates.
 */
public abstract class Function implements Serializable
{
  final String attributeName;
  private final String columnName;
  protected transient int attributeColumn;

  protected Function(String attributeName, String columnName)
  {
    this.columnName = columnName;
    this.attributeName = attributeName;
  }

  public String toString()
  {
    return getColumnName();
  }

  public String getColumnName()
  {
    return columnName;
  }

  public void init(Operand operand)
  {
    if (attributeName != null) {
      attributeColumn = operand.getColumn(attributeName);
      if (attributeColumn == -1)
        throw new RuntimeException(getClass().getName() + ": Unable to find " + attributeName);
    }
  }

  public Object processPartialResult(Object partialResult)
  {
    return partialResult;
  }

  public abstract Object processTuple(Object partialResult, Object[] tuple);
}
