package dascosa.algebra.project;

import dascosa.data.Operand;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 26.feb.2008
 * Time: 14:04:31
 * To change this template use File | Settings | File Templates.
 */
public final class Project implements ProjectOperation
{
  private final String attributeName;
  private transient int attributeColumn;

  public Project(String attributeName)
  {
    this.attributeName = attributeName;
  }

// --------------------- Begin Interface ProjectOperation ---------------------

  public Object executeOperation(Object tuple[])
  {
    return tuple[attributeColumn];
  }

  public String getColumnName()
  {
    return attributeName;
  }

  public void init(Operand operand)
  {
    attributeColumn = operand.getColumn(attributeName);
    if (attributeColumn == -1)
      throw new RuntimeException("Project: Unable to find " + attributeName);
  }

// --------------------- End Interface ProjectOperation ---------------------

  public String toString()
  {
    return getColumnName();
  }
}
