package dascosa.algebra.project;

import dascosa.data.Operand;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 26.feb.2008
 * Time: 14:07:33
 * To change this template use File | Settings | File Templates.
 */
public final class Rename implements ProjectOperation
{
  private final String oldAttributeName;
  private final String newAttributeName;
  private transient int attributeColumn;

  public Rename(String oldAttributeName, String newAttributeName)
  {
    this.oldAttributeName = oldAttributeName;
    this.newAttributeName = newAttributeName;
  }

// --------------------- Begin Interface ProjectOperation ---------------------

  public Object executeOperation(Object tuple[])
  {
    return tuple[attributeColumn];
  }

  public String getColumnName()
  {
    return newAttributeName;
  }

  public void init(Operand operand)
  {
    attributeColumn = operand.getColumn(oldAttributeName);
    if (attributeColumn == -1)
      throw new RuntimeException("Rename: Unable to find " + oldAttributeName);
  }

// --------------------- End Interface ProjectOperation ---------------------

  public String toString()
  {
    return oldAttributeName + " AS " + newAttributeName;
  }
}
