package dascosa.algebra.scan;

import dascosa.algebra.AlgebraNode;
import dascosa.data.PacketHeader;
import dascosa.data.PartialResult;
import dascosa.site.query.Executor;

import javax.sql.DataSource;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 01.apr.2008
 * Time: 16:43:44
 * To change this template use File | Settings | File Templates.
 */
public final class LogicalTableAccessNode extends TableAccessNode
{
  public LogicalTableAccessNode(AlgebraNode resultNode, String tableName)
  {
    super(resultNode, tableName, null, -1);
  }

  public LogicalTableAccessNode(AlgebraNode resultNode, String tableName, String asName)
  {
    super(resultNode, tableName, asName, -1);
  }

  public String toString()
  {
    return "LogicalTableAccess(" + getPhysicalTableName() + ')';
  }

  public boolean doOperation(Executor executor, DataSource dataSource)
  {
    throw new RuntimeException("Can't execute LogicalTableAccessNode");
  }

  @Override
  public boolean allTableNodesAssigned()
  {
    return false;
  }

  public PartialResult simulate()
  {
    PartialResult simulation = new PartialResult(1);
    List<String> columnNames = new ArrayList<String>();
    for (String attributeName : attributeNames)
      columnNames.add(getPrefix() + attributeName);
    simulation.addPacketHeader(null, new PacketHeader(columnNames, getOperationID(), getNodeID(), getResultNodeID(0)));
    return simulation;
  }
}
