package dascosa.data;

import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 16.jan.2009
 * Time: 14:22:00
 * To change this template use File | Settings | File Templates.
 */
public final class FinalResult
{
  private final PacketHeader headers[];

  public FinalResult(Operand operand)
  {
    PacketHeader operandHeaders[] = operand.getPacketHeaders();
    headers = new PacketHeader[operandHeaders.length];
    System.arraycopy(operandHeaders, 0, headers, 0, headers.length);
    Arrays.sort(headers, new Comparator<PacketHeader>()
    { // Deterministic order when displaying the result.
      public int compare(PacketHeader o1, PacketHeader o2)
      {
        if (o1 == null)
          return 1;
        if (o2 == null)
          return -1;
        return (int)(o1.getSourceAlgebraNodeID() - o2.getSourceAlgebraNodeID());
      }
    });
  }

  public String toString()
  {
    StringBuilder sb = new StringBuilder(headers[0].toLongString());
    for (int i = 1; i < headers.length; i++) {
      PacketHeader header = headers[i];
      for (int j = 0; j < header.getPacketCount(); j++)
        sb.append(header.getPacket(j).toLongString());
    }
    return sb.toString();
  }

  public int getTupleCount() // MainCommand, CacheNode, SQLPanel
  {
    int count = 0;
    for (PacketHeader header : headers)
      for (int i = 0; i < header.getPacketCount(); i++)
        count += header.getPacket(i).getTupleCount();
    return count;
  }
}
