package dascosa.gui;


import dascosa.Dascosa;
import dascosa.data.Packet;
import dascosa.message.*;
import dascosa.site.MessageListener;
import dascosa.site.SiteManager;
import rice.p2p.commonapi.Message;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 23.apr.2007
 * Time: 14:34:39
 * To change this template use File | Settings | File Templates.
 */
final class NetworkPanel extends JPanel implements ActionListener, MessageListener
{
  private final JButton bClear = new JButton("Clear log");
  private final JButton bKill = new JButton("Kill site");
  private final JButton bBoot = new JButton("Boot site");
  private final JCheckBox cbIncludeIndexMsg = new JCheckBox("Include index maintenance", false);
  private final JTextArea taLog = new JTextArea();
  private final MainPanel main;
  private SiteManager siteManager;
  private int receivedPacketCounter;

  NetworkPanel(MainPanel main)
  {
    super(new BorderLayout());
    this.main = main;
    taLog.setEditable(false);
    bBoot.setEnabled(false);
    bClear.addActionListener(this);
    bKill.addActionListener(this);
    bBoot.addActionListener(this);
    JPanel buttonPanel = new JPanel(new FlowLayout());
    buttonPanel.add(cbIncludeIndexMsg);
    buttonPanel.add(bClear);
    buttonPanel.add(bKill);
    buttonPanel.add(bBoot);
    
    add(new JLabel("Network log:"), BorderLayout.NORTH);
    add(new JScrollPane(taLog), BorderLayout.CENTER);
    add(buttonPanel, BorderLayout.SOUTH);
  }

// --------------------- Begin Interface ActionListener ---------------------

  public void actionPerformed(ActionEvent event)
  {
    if (event.getSource() == bClear)
      taLog.setText("");
    else if (event.getSource() == bKill)
      main.killNode();
    else if (event.getSource() == bBoot)
      try {
        main.bootNode();
      } catch (IOException e) {
        e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      } catch (InterruptedException e) {
        e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      }
  }

// --------------------- End Interface ActionListener ---------------------


// --------------------- Begin Interface MessageListener ---------------------

  public void messageDirect(Message message)
  {
    if (cbIncludeIndexMsg.isSelected() || !(message instanceof PublishTableMsg ||
                                            message instanceof PublishCacheMsg ||
                                            message instanceof MasterNotificationMsg))
      taLog.append("Direct " + message + '\n');
  }

  public void messageReceived(Message message)
  {
    if (message instanceof Packet) {
      receivedPacketCounter++;
      taLog.append("Received " + message + ' ' + receivedPacketCounter + '\n');
    }
    else if (cbIncludeIndexMsg.isSelected() || !(message instanceof PublishTableMsg ||
                                                 message instanceof PublishCacheMsg ||
                                                 message instanceof MasterNotificationMsg ||
                                                 message instanceof PyxidaMessage)) {
      taLog.append("Received " + message + '\n');
    }
    if (Dascosa.isPropertySet(Dascosa.USE_COORDINATES)) {
        if (cbIncludeIndexMsg.isSelected() && message instanceof PyxidaMessage) {

            String text = "Coordinates " + siteManager.getNCClient().getApplicationCoords().toString() + " Error " + siteManager.getNCClient().getSystemError() + '\n';
            taLog.append(text);
            taLog.setCaretPosition(taLog.getCaretPosition()+text.length());
        }
    }
  }

  public void messageSending(Message message)
  {
    if (cbIncludeIndexMsg.isSelected() || !(message instanceof PublishTableMsg ||
                                            message instanceof PublishCacheMsg ||
                                            message instanceof MasterNotificationMsg ||
                                            message instanceof PyxidaMessage)) {
      taLog.append("Sending " + message + '\n');
    }
  }

// --------------------- End Interface MessageListener ---------------------

  public void setEnabled(boolean enabled)
  {
    super.setEnabled(enabled);
    bClear.setEnabled(enabled);
    bKill.setEnabled(enabled);
    bBoot.setEnabled(!enabled);
  }

  void setSiteManager(SiteManager siteManager)
  {
    this.siteManager = siteManager;
  }
}
