package dascosa.gui;

import dascosa.algebra.AlgebraNode;

import javax.swing.*;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 25.aug.2007
 * Time: 13:57:10
 * To change this template use File | Settings | File Templates.
 */
final class NodePanel extends JPanel
{
  private final DefaultListModel executionModel = new DefaultListModel();
  private final DefaultListModel cacheModel = new DefaultListModel();
  private final DefaultListModel pausedModel = new DefaultListModel();

  NodePanel()
  {
    super(new GridLayout(2, 1, 5, 5));

    JPanel panel1 = new JPanel(new BorderLayout());
    panel1.add(new JLabel("Algebra nodes in processing"), BorderLayout.NORTH);
    JList executionList = new JList(executionModel);
    panel1.add(new JScrollPane(executionList), BorderLayout.CENTER);

    JPanel panel2 = new JPanel(new BorderLayout());
    panel2.add(new JLabel("Algebra nodes paused"), BorderLayout.NORTH);
    JList pausedList = new JList(pausedModel);
    panel2.add(new JScrollPane(pausedList), BorderLayout.CENTER);

    JPanel panel3 = new JPanel(new BorderLayout());
    panel3.add(new JLabel("Cached algebra nodes"), BorderLayout.NORTH);
    JList cacheList = new JList(cacheModel);
    panel3.add(new JScrollPane(cacheList), BorderLayout.CENTER);

    add(panel1);
    add(panel2);
    add(panel3);
  }

  void algbraNodeResumed(final AlgebraNode algebraNode)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        pausedModel.removeElement(algebraNode);
        executionModel.addElement(algebraNode);
      }
    });
  }

  void algebraNodeAdded(final AlgebraNode algebraNode)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        executionModel.addElement(algebraNode);
      }
    });
  }

  void algebraNodeFinished(final AlgebraNode algebraNode)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        executionModel.removeElement(algebraNode);
        cacheModel.addElement(algebraNode);
      }
    });
  }

  void algebraNodePaused(final AlgebraNode algebraNode)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        pausedModel.addElement(algebraNode);
        executionModel.removeElement(algebraNode);
      }
    });
  }

  void algebraNodeRemoved(final AlgebraNode algebraNode)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        cacheModel.removeElement(algebraNode);
      }
    });
  }

  void algebraNodesCleared()
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        executionModel.clear();
        cacheModel.clear();
      }
    });
  }
}
