package dascosa.gui;

import dascosa.site.fault.CacheListener;
import rice.p2p.commonapi.Message;

import javax.swing.*;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 25.aug.2007
 * Time: 13:57:23
 * To change this template use File | Settings | File Templates.
 */
final class RestartCachePanel extends JPanel implements CacheListener
{
  private final DefaultListModel packetModel = new DefaultListModel();

  RestartCachePanel()
  {
    super(new BorderLayout());
    add(new JLabel("Restart cache contents:"), BorderLayout.NORTH);
    JList packetList = new JList(packetModel);
    add(new JScrollPane(packetList), BorderLayout.CENTER);
  }

// --------------------- Begin Interface CacheListener ---------------------

  public void restartPacketAdded(final Message message)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        packetModel.addElement(message);
      }
    });
  }

  public void restartPacketRemoved(final Message message)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        packetModel.removeElement(message);
      }
    });
  }

  public void restartPacketsCleared()
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        packetModel.clear();
      }
    });
  }

  public void semanticCacheEntryAdded(String query)
  {
  }

  public void semanticCacheEntryRemoved(String query)
  {
  }

  public void semanticCacheCleared()
  {
  }

// --------------------- End Interface CacheListener ---------------------
}
