package dascosa.gui;

import dascosa.site.fault.CacheListener;

import javax.swing.*;
import java.awt.*;

import rice.p2p.commonapi.Message;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 22.mar.2009
 * Time: 14:39:47
 * To change this template use File | Settings | File Templates.
 */
final class SemanticCachePanel extends JPanel implements CacheListener
{
  private final DefaultListModel cacheModel = new DefaultListModel();

  SemanticCachePanel()
  {
    super(new BorderLayout());
    add(new JLabel("Semantic cache contents:"), BorderLayout.NORTH);
    JList packetList = new JList(cacheModel);
    add(new JScrollPane(packetList), BorderLayout.CENTER);
  }

// --------------------- Begin Interface CacheListener ---------------------

  public void restartPacketAdded(Message message)
  {
  }

  public void restartPacketRemoved(Message message)
  {
  }

  public void restartPacketsCleared()
  {
  }

  public void semanticCacheEntryAdded(final String query)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        cacheModel.addElement(query);
      }
    });

  }

  public void semanticCacheEntryRemoved(final String query)
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        cacheModel.removeElement(query);
      }
    });
  }

  public void semanticCacheCleared()
  {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        cacheModel.clear();
      }
    });
  }

// --------------------- End Interface CacheListener ---------------------
}
