package dascosa.message;

import dascosa.site.index.Interval;
import rice.p2p.commonapi.Message;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 04.jul.2008
 * Time: 12:18:22
 * To change this template use File | Settings | File Templates.
 */
public final class MasterNotificationMsg implements Message
{
  private final Interval assigned;
  private final String tableName;
  private final int fragmentNr;

  public MasterNotificationMsg(String tableName, int fragmentNr, Interval assigned)
  {
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.assigned = assigned;
  }

// --------------------- Begin Interface Message ---------------------

  public int getPriority()
  {
    return Message.MEDIUM_PRIORITY;
  }

// --------------------- End Interface Message ---------------------

  public String toString()
  {
    return "MasterNotification(" + tableName + ',' + fragmentNr + ')';
  }

  public Interval getAssigned()
  {
    return assigned;
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public String getTableName()
  {
    return tableName;
  }
}
