package dascosa.message;

import dascosa.site.query.optimizer.ResultSetIdentifier;
import edu.harvard.syrah.pyxida.nc.lib.Coordinate;
import rice.p2p.commonapi.Message;
import rice.p2p.commonapi.NodeHandle;

/**
 * Created by IntelliJ IDEA.
 * User: ryeng
 * Date: Feb 29, 2008
 * Time: 1:56:23 PM
 * To change this template use File | Settings | File Templates.
 */
public final class PublishCacheMsg implements Message
{
  private final NodeHandle site;
  private final String[] query;
  private final ResultSetIdentifier[] rsi;
  private final Coordinate coordinate;

  public PublishCacheMsg(NodeHandle site, ResultSetIdentifier[] rsi, String query[], Coordinate coordinate)
  {
    this.site = site;
    this.query = query;
    this.rsi = rsi;
    this.coordinate = coordinate;
  }

// --------------------- Begin Interface Message ---------------------

  public int getPriority()
  {
    return Message.MEDIUM_PRIORITY;
  }

// --------------------- End Interface Message ---------------------

  public String toString()
  {
    return "Publish(" + query + ')';
  }

  public String[] getQueries()
  {
    return query;
  }

  public NodeHandle getSite()
  {
    return site;
  }

  public ResultSetIdentifier[] getResultSetIdentifier() {
    return rsi;
  }

  public Coordinate getCoordinate() {
    return coordinate;
  }



}
