/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dascosa.message;

import dascosa.Dascosa;
import dascosa.site.query.optimizer.ResultSetIdentifier;
import dascosa.util.FilteredOutput;
import edu.harvard.syrah.pyxida.nc.lib.Coordinate;
import rice.p2p.commonapi.Message;
import rice.p2p.commonapi.NodeHandle;

/**
 *
 * @author jan
 */
public final class PublishResultSetUsageMsg implements Message{

  private final Coordinate coordinates;
  private final ResultSetIdentifier rsid;
  private final NodeHandle site;
  private final double cost;
  private final int size;

  public PublishResultSetUsageMsg(Coordinate coordinates, ResultSetIdentifier rsid, NodeHandle site, double cost, int size) {
    this.coordinates = coordinates;
    this.rsid = rsid;
    this.site = site;
    this.cost = cost;
    this.size = size;
    
    Dascosa.out.println(FilteredOutput.CACHEINVESTMENT, "CacheInvestment: Reporting " + rsid.toString() + " from " + site.toString() + " at " + coordinates.toString());
  }

  public double getCost() {
    return cost;
  }
  
  @Override
  public int getPriority() {
    return Message.MEDIUM_PRIORITY;
  }

  public Coordinate getCoordinates() {
    return coordinates;
  }

  public ResultSetIdentifier getResultSetIdentifier() {
    return rsid;
  }

  public NodeHandle getSite() {
    return site;
  }

  public int getSize() {
    return size;
  }




}
