package dascosa.message;

import dascosa.site.query.optimizer.Histogram;
import edu.harvard.syrah.pyxida.nc.lib.Coordinate;
import rice.p2p.commonapi.Message;
import rice.p2p.commonapi.NodeHandle;

import java.util.HashMap;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 20.apr.2007
 * Time: 15:07:11
 * To change this template use File | Settings | File Templates.
 */
public final class PublishTableMsg implements Message
{
  private final Coordinate coordinate;
  private final HashMap<String, Histogram> histograms;
  private final Integer minUsed;
  private final Integer maxUsed;
  private final NodeHandle site;
  private final String tableName;
  private final String primaryKey;
  private final String attributeNames[];
  private final int fragmentNr;
  private final int tupleCount;


  public PublishTableMsg(NodeHandle site, String tableName, int fragmentNr,
                         String primaryKey, String attributeNames[],
                         Integer minUsed, Integer maxUsed, Integer tupleCount,
                         HashMap<String, Histogram> histograms, Coordinate coordinate)
  {
    this.site = site;
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.primaryKey = primaryKey;
    this.attributeNames = attributeNames;
    this.minUsed = minUsed;
    this.maxUsed = maxUsed;
    this.tupleCount = tupleCount;
    this.histograms = histograms;
    this.coordinate = coordinate;
  }

// --------------------- Begin Interface Message ---------------------

  public int getPriority()
  {
    return Message.MEDIUM_PRIORITY;
  }

// --------------------- End Interface Message ---------------------

  public String toString()
  {
    return "Publish(" + tableName + ',' + tableName + ')';
  }

  public String[] getAttributeNames()
  {
    return attributeNames;
  }

  public Coordinate getCoordinate()
  {
    return coordinate;
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public HashMap<String, Histogram> getHistograms()
  {
    return histograms;
  }

  public Integer getMaxUsed()
  {
    return maxUsed;
  }

  public Integer getMinUsed()
  {
    return minUsed;
  }

  public String getPrimaryKey()
  {
    return primaryKey;
  }

  public NodeHandle getSite()
  {
    return site;
  }

  public String getTableName()
  {
    return tableName;
  }

  public int getTupleCount()
  {
    return tupleCount;
  }
}
