package dascosa.message.flood;

import rice.p2p.commonapi.Message;
import rice.p2p.commonapi.NodeHandle;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 22.nov.2007
 * Time: 12:45:58
 * To change this template use File | Settings | File Templates.
 */
public abstract class AbstractFloodRequestMsg implements Message
{
  private final List<NodeHandle> leafs = new ArrayList<NodeHandle>();
  private NodeHandle returnToSite;
  private long id;

// --------------------- Begin Interface Message ---------------------

  public int getPriority()
  {
    return Message.LOW_PRIORITY;
  }

// --------------------- End Interface Message ---------------------

  public void addLeaf(NodeHandle nodeHandle)
  {
    leafs.add(nodeHandle);
  }

  public void clearLeafs()
  {
    leafs.clear();
  }

  public long getID()
  {
    return id;
  }

  public List<NodeHandle> getLeafs()
  {
    return leafs;
  }

  public NodeHandle getReturnToSite()
  {
    return returnToSite;
  }

  public void setReturnToSite(NodeHandle returnToSite)
  {
    this.returnToSite = returnToSite;
  }

  public void setID(long id)
  {
    this.id = id;
  }
}
