package dascosa.message.flood;

/**
 * Created by IntelliJ IDEA.
 * User: ryeng
 * Date: Jun 13, 2008
 * Time: 12:38:02 PM
 * To change this template use File | Settings | File Templates.
 */
public final class SetCacheParametersMsg extends AbstractFloodRequestMsg
{
  private final Boolean flush;
  private final Double sizeFactor;
  private final Double costFactor;
  private final Double depthFactor;
  private final Double lastUsedFactor;
  private final Integer cacheSize;

  public SetCacheParametersMsg(boolean flush, int cacheSize, double sizeFactor, double costFactor, double depthFactor, double lastUsedFactor)
  {
    this.flush = flush;
    this.cacheSize = cacheSize;
    this.sizeFactor = sizeFactor;
    this.costFactor = costFactor;
    this.depthFactor = depthFactor;
    this.lastUsedFactor = lastUsedFactor;
  }

  public String toString()
  {
    return "SetCacheParametersMsg()";
  }

  public Integer getCacheSize()
  {
    return cacheSize;
  }

  public Double getCostFactor()
  {
    return costFactor;
  }

  public Double getDepthFactor()
  {
    return depthFactor;
  }

  public boolean getFlush()
  {
    return flush;
  }

  public Double getLastUsedFactor()
  {
    return lastUsedFactor;
  }

  public Double getSizeFactor()
  {
    return sizeFactor;
  }
}
