package dascosa.message.request;

import rice.p2p.commonapi.NodeHandle;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 10.jul.2008
 * Time: 13:59:42
 * To change this template use File | Settings | File Templates.
 */
public final class FragmentSplitRequestMsg extends AbstractRequestMsg
{
  private final NodeHandle replicateSites[];
  private final String tableName;
  private final int oldFragmentNr;
  private final int newFragmentNr;
  private final long minValue;

  public FragmentSplitRequestMsg(String tableName, int oldFragmentNr, int newFragmentNr, long minValue,
                                 NodeHandle replicateSites[])
  {
    this.tableName = tableName;
    this.oldFragmentNr = oldFragmentNr;
    this.newFragmentNr = newFragmentNr;
    this.minValue = minValue;
    this.replicateSites = replicateSites;
  }

  public String toString()
  {
    return "FragmentSplitRequest(" + tableName + ',' + oldFragmentNr + ',' + newFragmentNr + ',' + minValue + ')';
  }

  public long getMinValue()
  {
    return minValue;
  }

  public int getNewFragmentNr()
  {
    return newFragmentNr;
  }

  public int getOldFragmentNr()
  {
    return oldFragmentNr;
  }

  public NodeHandle[] getReplicateSites()
  {
    return replicateSites;
  }

  public String getTableName()
  {
    return tableName;
  }
}
