package dascosa.message.request;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 10.jul.2008
 * Time: 14:03:18
 * To change this template use File | Settings | File Templates.
 */
public final class FragmentSplitResponseMsg extends AbstractResponseMsg
{
  private final String tableName;
  private final String definition;
  private final byte data[];
  private final int fragmentNr;

  public FragmentSplitResponseMsg(AbstractRequestMsg request, String tableName, int fragmentNr,
                                  String definition, byte[] data, boolean isLast)
  {
    super(request, isLast);
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.definition = definition;
    this.data = data;
  }

  public String toString()
  {
    return "FragmentSplitResponse(" + tableName + '_' + fragmentNr + ')';
  }

  public byte[] getData()
  {
    return data;
  }

  public String getDefinition()
  {
    return definition;
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public String getTableName()
  {
    return tableName;
  }
}
