package dascosa.message.request;

import dascosa.site.update.CommitStatement;
import rice.p2p.commonapi.NodeHandle;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 21.nov.2007
 * Time: 14:08:58
 * To change this template use File | Settings | File Templates.
 */
public final class InsertRequestMsg extends AbstractRequestMsg
{
  private final CommitStatement commitStatement;
  private final NodeHandle replicateSites[];
  private final String tableName;
  private final int fragmentNr;
  private final int pkValue;

  public InsertRequestMsg(CommitStatement commitStatement, String tableName,
                          int fragmentNr, NodeHandle replicateSites[], int pkValue)
  {
    this.commitStatement = commitStatement;
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.replicateSites = replicateSites;
    this.pkValue = pkValue;
  }

  public String toString()
  {
    return "InsertRequest(" + commitStatement + ')';
  }

  public CommitStatement getCommitStatement()
  {
    return commitStatement;
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public int getPkValue()
  {
    return pkValue;
  }

  public NodeHandle[] getReplicateSites()
  {
    return replicateSites;
  }

  public String getTableName()
  {
    return tableName;
  }
}
