package dascosa.message.request;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 17.okt.2007
 * Time: 15:17:43
 * To change this template use File | Settings | File Templates.
 */
public final class LockResponseMsg extends AbstractResponseMsg
{
  private final String tableName;
  private final boolean granted;
  private final int fragmentNr;

  public LockResponseMsg(LockRequestMsg request, boolean granted)
  {
    super(request);
    tableName = request.getTableName();
    fragmentNr = request.getFragmentNr();
    this.granted = granted;
  }

  public String toString()
  {
    return "LockResponse(" + tableName + ',' + fragmentNr + ',' + granted + ')';
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public String getTableName()
  {
    return tableName;
  }

  public boolean isGranted()
  {
    return granted;
  }
}
