package dascosa.message.request;

import rice.p2p.commonapi.NodeHandle;

import java.util.Arrays;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 22.jul.2008
 * Time: 13:49:01
 * To change this template use File | Settings | File Templates.
 */
public final class LookupPKResponseMsg extends AbstractResponseMsg
{
  private final NodeHandle sites[];
  private final String tableName;
  private final int fragmentNr;
  private final int masterIndex; // Which site in sites has the master fragment?

  public LookupPKResponseMsg(AbstractRequestMsg request, String tableName, int fragmentNr,
                             NodeHandle sites[], int masterIndex)
  {
    super(request);
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.sites = sites;
    this.masterIndex = masterIndex;
  }

  public String toString()
  {
    return "LookupPKResponse(" + tableName + " => " + Arrays.deepToString(sites) + ')';
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public int getMasterIndex()
  {
    return masterIndex;
  }

  public NodeHandle[] getSites()
  {
    return sites;
  }

  public String getTableName()
  {
    return tableName;
  }
}
