package dascosa.message.request;

import dascosa.site.query.optimizer.ResultSetIdentifier;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 26.apr.2007
 * Time: 14:36:28
 * To change this template use File | Settings | File Templates.
 */
public final class LookupRequestMsg extends AbstractRequestMsg
{
  public static final int ALL_FRAGMENTS = -1;
  private final String tableName;
  private final String query;
  private final int fragmentNr;
  private final ResultSetIdentifier[] rsi;

  public LookupRequestMsg(String tableName)
  {
    this(tableName, ALL_FRAGMENTS);
  }

  public LookupRequestMsg(String tableName, int fragmentNr)
  {
    this(tableName, fragmentNr, null);
  }

  public LookupRequestMsg(String tableName, int fragmentNr, String query)
  {
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.query = query;
    rsi = null;
  }

    public LookupRequestMsg(String tableName, int fragmentNr, String query, ResultSetIdentifier[] rsi)
  {
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.query = query;
    this.rsi = rsi;
  }

  public ResultSetIdentifier[] getResultSetIdentifier() {
    return rsi;
  }

  public String toString()
  {
    return "LookupRequest(" + tableName + ')';
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public String getQuery()
  {
    return query;
  }

  public String getTableName()
  {
    return tableName;
  }
}
