package dascosa.message.request;

import dascosa.site.update.CommitStatement;
import rice.p2p.commonapi.NodeHandle;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 07.nov.2007
 * Time: 13:29:04
 * To change this template use File | Settings | File Templates.
 */
public final class StatementRequestMsg extends AbstractRequestMsg
{
  private final CommitStatement commitStatement;
  private final NodeHandle replicates[];
  private final String tableName;
  private final int fragmentNr;

  public StatementRequestMsg(CommitStatement commitStatement, String tableName,
                             int fragmentNr, NodeHandle replicates[])
  {
    this.commitStatement = commitStatement;
    this.tableName = tableName;
    this.fragmentNr = fragmentNr;
    this.replicates = replicates;
  }

  public String toString()
  {
    return "StatementRequest(" + commitStatement + ')';
  }

  public CommitStatement getCommitStatement()
  {
    return commitStatement;
  }

  public int getFragmentNr()
  {
    return fragmentNr;
  }

  public NodeHandle[] getReplicates()
  {
    return replicates;
  }

  public String getTableName()
  {
    return tableName;
  }
}
