package dascosa.message.restart;

import dascosa.algebra.AlgebraNode;
import rice.p2p.commonapi.Message;

import java.util.Arrays;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 29.aug.2007
 * Time: 10:36:48
 * To change this template use File | Settings | File Templates.
 */
public final class PartialRestartFailedMsg implements Message
{
  private final AlgebraNode algebraNode;
  private final int packetTags[];

  public PartialRestartFailedMsg(AlgebraNode algebraNode, int[] packetTags)
  {
    this.algebraNode = algebraNode;
    this.packetTags = packetTags;
  }

// --------------------- Begin Interface Message ---------------------

  public int getPriority()
  {
    return Message.LOW_PRIORITY;
  }

// --------------------- End Interface Message ---------------------

  public String toString()
  {
    return "PartialRestartFailed(" + algebraNode + " - " + Arrays.toString(packetTags) + ')';
  }

  public AlgebraNode getAlgebraNode()
  {
    return algebraNode;
  }

  public int[] getPacketTags()
  {
    return packetTags;
  }
}
