package dascosa.message.restart;

import dascosa.algebra.AlgebraNode;
import rice.p2p.commonapi.Message;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 06.sep.2007
 * Time: 15:06:42
 * To change this template use File | Settings | File Templates.
 */
public final class PartialRestartOperandMsg implements Message
{
  private final AlgebraNode algebraNode;
  private final int tuplesToSkip;

  public PartialRestartOperandMsg(AlgebraNode algebraNode, int tuplesToSkip)
  {
    this.algebraNode = algebraNode;
    this.tuplesToSkip = tuplesToSkip;
  }

// --------------------- Begin Interface Message ---------------------

  public int getPriority()
  {
    return Message.LOW_PRIORITY;
  }

// --------------------- End Interface Message ---------------------

  public String toString()
  {
    return "PartialRestartOperand(" + algebraNode + " - " + tuplesToSkip + ')';
  }

  public AlgebraNode getAlgebraNode()
  {
    return algebraNode;
  }

  public int getTuplesToSkip()
  {
    return tuplesToSkip;
  }
}
