/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dascosa.site;

import dascosa.Dascosa;
import dascosa.message.PyxidaMessage;
import edu.harvard.syrah.pyxida.nc.lib.Coordinate;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;
import rice.pastry.NodeHandle;

/**
 *
 * @author jan
 */
public final class PyxidaHandler implements ActionListener {

    private static final int CHECK_FREQUENCY = 15000;
    //private static final int NUM_NEIGHBORS = 3;
    private final NetworkLayer networkLayer;
    private final SiteManager siteManager;

    public PyxidaHandler(NetworkLayer networkLayer, SiteManager siteManager) {
        this.networkLayer = networkLayer;
        this.siteManager = siteManager;

        Timer pyxidaCheckTimer = new Timer(CHECK_FREQUENCY, this);
        pyxidaCheckTimer.setRepeats(true);
        if(Dascosa.isPropertySet(Dascosa.USE_COORDINATES))
            pyxidaCheckTimer.start();
    }

    public void processMessage(PyxidaMessage message) {

        double rttSample = siteManager.getPastryNode().proximity(message.getRemoteSite());

        if (!siteManager.getNCClient().containsHost(message.getRemoteSite())) {
            siteManager.getNCClient().addHost(message.getRemoteSite());
        }
        siteManager.getNCClient().processSample(
                message.getRemoteSite(),
                message.getCoordinate(),
                message.getError(),
                rttSample,
                message.getAge(),
                System.currentTimeMillis(),
                siteManager.getNCClient().containsHost(message.getRemoteSite()));
    /*
    if (!networkLayer.getNeighbors(NUM_NEIGHBORS).contains(message.getRemoteSite())) {
    
    Coordinate coordinate = siteManager.getNCClient().getSystemCoords();
    double error = siteManager.getNCClient().getSystemError();
    long age = siteManager.getNCClient().getAge(System.currentTimeMillis());
    NodeHandle site = (NodeHandle) siteManager.getLocalSite();
    
    networkLayer.sendMessage(new PyxidaMessage(coordinate, age, error, site), (rice.p2p.commonapi.NodeHandle) message.getRemoteSite());
    }
     */
    }

    public void actionPerformed(ActionEvent arg0) {
        //List<rice.p2p.commonapi.NodeHandle> neighbors = networkLayer.getNeighbors(NUM_NEIGHBORS);

        Coordinate coordinate = siteManager.getNCClient().getSystemCoords();
        double error = siteManager.getNCClient().getSystemError();
        long age = siteManager.getNCClient().getAge(System.currentTimeMillis());
        NodeHandle site = (NodeHandle) siteManager.getLocalSite();

        for (NodeHandle node : siteManager.getPastryNode().getLeafSet()) {
            networkLayer.sendMessage(new PyxidaMessage(coordinate, age, error, site), node);
        }
    /*        
    for (rice.p2p.commonapi.NodeHandle neighbor : neighbors) {
    networkLayer.sendMessage(new PyxidaMessage(coordinate, age, error, site), neighbor);
    }
    
    for (Object neighbor : siteManager.getNCClient().getHosts()) {
    networkLayer.sendMessage(new PyxidaMessage(coordinate, age, error, site), (rice.p2p.commonapi.NodeHandle)neighbor);
    }
     */
    }
}
