package dascosa.site;

import dascosa.Dascosa;
import dascosa.message.request.*;
import dascosa.util.FilteredOutput;
import rice.p2p.commonapi.NodeHandle;

import javax.sql.DataSource;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 24.okt.2007
 * Time: 13:44:15
 * To change this template use File | Settings | File Templates.
 */
public final class RequestResponseManager
{
  private final Map<Long, MessageClient> clients = new HashMap<Long, MessageClient>();
  private final Map<Long, Object[]> parameters = new HashMap<Long, Object[]>();
  private final NetworkLayer networkLayer;
  private final Random random = new Random(System.currentTimeMillis());
  private final SiteManager siteManager;

  RequestResponseManager(SiteManager siteManager, NetworkLayer networkLayer)
  {
    this.networkLayer = networkLayer;
    this.siteManager = siteManager;
  }

  public synchronized void responseReceived(AbstractResponseMsg message, DataSource dataSource)
  {
    if (message instanceof HistogramResponseMessage)
      Dascosa.out.println(FilteredOutput.DATA_STATISTICS, message.toString());
    if (message.isLast()) {
      MessageClient client = clients.remove(message.getID());
      Object parameter[] = parameters.remove(message.getID());
      client.responseReceived(message, parameter, dataSource);
    }
    else {
      MessageClient client = clients.get(message.getID());
      Object parameter[] = parameters.get(message.getID());
      client.responseReceived(message, parameter, dataSource);
    }  
  }

  public synchronized void sendRequest(AbstractRequestMsg message, String string,
                                       MessageClient client, Object parameter[])
  {
    long id = random.nextLong();
    clients.put(id, client);
    parameters.put(id, parameter);
    message.setID(id);
    message.setReturnToSite(siteManager.getLocalSite());
    networkLayer.sendMessage(message, string);
  }

  public synchronized void sendRequest(AbstractRequestMsg message, NodeHandle targetSite,
                                       MessageClient client, Object parameter[])
  {
    long id = random.nextLong();
    clients.put(id, client);
    parameters.put(id, parameter);
    message.setID(id);
    message.setReturnToSite(siteManager.getLocalSite());
    networkLayer.sendMessage(message, targetSite);
  }
}
