package dascosa.site.fault;

import rice.p2p.commonapi.NodeHandle;

import java.util.Collection;
import java.util.HashSet;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 27.aug.2007
 * Time: 12:39:05
 * To change this template use File | Settings | File Templates.
 */
final class FaultDetectEntry
{
  private final Collection<Long> algebraNodeIDs = new HashSet<Long>();
  private final NodeHandle site;
  private boolean checkSent;
  private long lastMessage;

  FaultDetectEntry(NodeHandle site)
  {
    this.site = site;
    lastMessage = System.currentTimeMillis();
  }

  void addAlgebraNodeID(long algebraNodeID)
  {
    algebraNodeIDs.add(algebraNodeID);
  }

  void checkSent()
  {
    checkSent = true;
    lastMessage = System.currentTimeMillis();
  }

  Collection<Long> getAlgebraNodeIDs()
  {
    return algebraNodeIDs;
  }

  NodeHandle getSite()
  {
    return site;
  }

  boolean isCheckSent()
  {
    return checkSent;
  }

  boolean isEmpty()
  {
    return algebraNodeIDs.isEmpty();
  }

  boolean isSuspectedDead()
  {
    return lastMessage + FaultDetector.MESSAGE_TIMEOUT < System.currentTimeMillis();
  }

  void messageReceived()
  {
    lastMessage = System.currentTimeMillis();
    checkSent = false;
  }

  void removeAlgebraNodeID(long algebraNodeID)
  {
    algebraNodeIDs.remove(algebraNodeID);
  }
}
