package dascosa.site.index;

import dascosa.Dascosa;
import dascosa.site.query.optimizer.ResultSetIdentifier;
import dascosa.util.FilteredOutput;
import edu.harvard.syrah.pyxida.nc.lib.Coordinate;
import rice.p2p.commonapi.NodeHandle;

/**
 * Created by IntelliJ IDEA.
 * User: ryeng
 * Date: Feb 29, 2008
 * Time: 1:19:01 PM
 * To change this template use File | Settings | File Templates.
 */
final class IndexCache
{
  private final NodeHandle site;
  private final String query;
  private final ResultSetIdentifier rsi;
  private final Coordinate coordinate;
  private long lastUpdate;

  IndexCache(String query, ResultSetIdentifier rsi, NodeHandle site, Coordinate coordinate)
  {
    this.query = query;
    this.rsi = rsi;
    this.site = site;
    this.coordinate = coordinate;
    lastUpdate = System.currentTimeMillis();
  }

  public ResultSetIdentifier getResultSetIdentifier() {
    return rsi;
  }

  public String toString()
  {
    return "Cache: " + query + '@' + site.getId().toString();
  }

  NodeHandle getSite()
  {
    return site;
  }

  public Coordinate getCoordinate() {
    return coordinate;
  }

  boolean isValid()
  {
    return lastUpdate + Index.INDEX_CLEAR_INTERVAL > System.currentTimeMillis();
  }

  void refresh()
  {
    //if (rsi.getTables().size() == 1) Dascosa.out.println(FilteredOutput.DEBUG, "DEBUG: Indexed single table " + query);
    lastUpdate = System.currentTimeMillis();
  }
}
