package dascosa.site.index;

import edu.harvard.syrah.pyxida.nc.lib.Coordinate;
import rice.p2p.commonapi.NodeHandle;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 10.mai.2007
 * Time: 14:04:06
 * To change this template use File | Settings | File Templates.
 */
final class IndexReplicate
{
  private final NodeHandle site;
  private Coordinate coordinate;
  private boolean isMaster;
  private long lastUpdate;

  IndexReplicate(NodeHandle site, Coordinate coordinate)
  {
    this.site = site;
    lastUpdate = System.currentTimeMillis();
    this.coordinate = coordinate;
  }

  public String toString()
  {
    if (isMaster)
      return '*' + site.getId().toString();
    else
      return site.getId().toString();
  }

  Coordinate getCoordinate()
  {
    return coordinate;
  }

  void setCoordinate(Coordinate coordinate)
  {
    this.coordinate = coordinate;
  }

  NodeHandle getSite()
  {
    return site;
  }

  boolean isMaster()
  {
    return isMaster;
  }

  boolean isValid()
  {
    return lastUpdate + Index.INDEX_CLEAR_INTERVAL > System.currentTimeMillis();
  }

  void refresh()
  {
    lastUpdate = System.currentTimeMillis();
  }

  void setMaster(boolean master)
  {
    isMaster = master;
  }
}
