package dascosa.site.index;

import java.io.Serializable;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 19.okt.2007
 * Time: 15:17:15
 * To change this template use File | Settings | File Templates.
 */
public final class Interval implements Comparable<Interval>, Serializable
{
  private final int min;
  private final int max;

  Interval(int min, int max)
  {
    this.min = min;
    this.max = max;
  }

// --------------------- Begin Interface Comparable ---------------------

  public int compareTo(Interval interval)
  {
    if (min < interval.min)
      return -1;
    else if (min > interval.min)
      return 1;
    else
      return 0;
  }

// --------------------- End Interface Comparable ---------------------

  public boolean equals(Object obj)
  {
    if (obj instanceof Interval) {
      Interval other = (Interval)obj;
      return min == other.min && max == other.max;
    }
    return false;
  }

  public String toString()
  {
    return "[" + min + ',' + max + ']';
  }

  public int getMax()
  {
    return max;
  }

  public int getMin()
  {
    return min;
  }

  boolean contains(int value)
  {
    return value >= min && value <= max;
  }

  boolean intersects(Interval interval)
  {
    return (min >= interval.min && min <= interval.max) ||
           (max >= interval.min && max <= interval.max);
  }
}
