package dascosa.site.query;

import dascosa.algebra.AlgebraNode;
import dascosa.data.Packet;
import dascosa.message.QueryStatsMsg;
import rice.p2p.commonapi.Message;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 06.sep.2007
 * Time: 13:42:36
 * To change this template use File | Settings | File Templates.
 */
final class QueryStats
{
  private final Map<AlgebraNode, Integer> tuplesSent = new HashMap<AlgebraNode, Integer>();

  synchronized Message getQueryStats(AlgebraNode algebraNode)
  {
    Integer count = tuplesSent.remove(algebraNode);
    if (count == null)
      return new QueryStatsMsg(0);
    else
      return new QueryStatsMsg(count);
  }

  synchronized void packetSent(AlgebraNode sourceNode, Packet packet)
  {
    Integer count = tuplesSent.get(sourceNode);
    if (count == null)
      tuplesSent.put(sourceNode, packet.getTupleCount());
    else
      tuplesSent.put(sourceNode, count + packet.getTupleCount());
  }
}
