/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dascosa.site.query.optimizer;

import dascosa.Dascosa;
import dascosa.algebra.constraints.SimpleConstraint;
import dascosa.util.FilteredOutput;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import rice.p2p.commonapi.NodeHandle;

/**
 *
 * @author jan
 */
public final class BaseAccessOption extends Option{

	private final int tupleCount;
    private final int fragmentNr;
    public final long operationID;
    private final String[] attributes;
    private final Set<String> joinAttributes;
        
    public BaseAccessOption(NodeHandle site, Set<String> tables, int tupleCount, int fragmentNr, long operationID, String[] attributes, Set<String> joinAttributes, Set<SimpleConstraint> queryConstraints) {
        super(site, tables);
        this.tupleCount = tupleCount;
        this.fragmentNr = fragmentNr;
        this.operationID = operationID;
        this.attributes = attributes;
        this.joinAttributes = joinAttributes;
        super.addConstraints(queryConstraints);

        Dascosa.out.println(FilteredOutput.DEBUG, "DEBUG: BaseAccessOption created for " + tables.toString() + " with " + queryConstraints.toString());
    }
    
    public int getFragmentNr() {
        return fragmentNr;
    }   
    
    @Override
    public int getPriorCost() {
        return 0;
    }

    @Override
    public int getTupleCount() {
        return (int)(tupleCount*getConstraintReductionFactor());
    }

	@Override
	public Iterator<Option> getSubOptions() {
		return new Iterator<Option>(){
			public boolean hasNext() {
				return false;
			}

			public Option next() {
				throw new IndexOutOfBoundsException();
			}

			public void remove() {
				throw new IndexOutOfBoundsException();
			}
			
		};
	}

	@Override
	public String getTableNameForAttribute(String attribute) {
		if (joinAttributes.contains(attribute))
			return tables.iterator().next();
		else
			return null;
	}

	@Override
	public ArrayList<Histogram> getHistograms(String table, String attribute) {
		ArrayList<Histogram> result = new ArrayList<Histogram>();
		if (tables.contains(table))
			result.add(DataStatistics.getInstance().getHistogram(new HistogramIdentifier(table, fragmentNr, attribute)));
		return result;
	}

  @Override
  protected void attributesContained(Map<String, Boolean> contained) {
    for (String attribute : attributes) {
      if (contained.containsKey(attribute))
        contained.put(attribute,true);
    }
  }

}
