/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dascosa.site.query.optimizer;

import dascosa.Dascosa;
import dascosa.algebra.constraints.SimpleConstraint;
import dascosa.util.FilteredOutput;

import java.util.*;

import rice.p2p.commonapi.NodeHandle;

/**
 *
 * @author jan
 */
public final class CacheOption extends Option {

  private final int cost;
  //private final int numTuples;
  private List<Option> alternativePlan;
  private final ResultSetIdentifier resultSetIdentifier;

  public CacheOption(NodeHandle site, int cost, ResultSetIdentifier rsi, Set<SimpleConstraint> queryConstraints) {
    super(site, rsi.getTables());
    this.cost = cost;
    //this.numTuples = numTuples;
    this.resultSetIdentifier = rsi;
    super.addConstraints(CacheOption.constraintsNotInRSI(rsi, queryConstraints));
    Dascosa.out.println(FilteredOutput.DEBUG, "DEBUG: CacheOption created for " + tables.toString() + " with " + queryConstraints.toString());
  }

  private static Set<SimpleConstraint> constraintsNotInRSI(ResultSetIdentifier rsi, Set<SimpleConstraint> queryConstraints) {

    Set<SimpleConstraint> filteredConstraints = new HashSet<SimpleConstraint>();

    for (SimpleConstraint c : queryConstraints) {
      if (!rsi.getConstraints().contains(c))
        filteredConstraints.add(c);
    }

    return filteredConstraints;
  }

  public Iterable<Option> getAlternativePlan() {
    return alternativePlan;
  }

  @Override
  public int getPriorCost() {
    return cost;
  }

  @Override
  public int getTupleCount() {
    return (int)(resultSetIdentifier.getTupleCount()*getConstraintReductionFactor());
  }

  @Override
  protected String getTableNameForAttribute(String attribute) {
    throw new UnsupportedOperationException("Not supported yet.");
  }

  @Override
  public Iterator<Option> getSubOptions() {
    return new Iterator<Option>() {

      public boolean hasNext() {
        return false;
      }

      public Option next() {
        throw new IndexOutOfBoundsException();
      }

      public void remove() {
        throw new IndexOutOfBoundsException();
      }
    };
  }

  @Override
  protected Collection<Histogram> getHistograms(String table, String attribute) {
    throw new UnsupportedOperationException("Not supported yet.");
  }

  @Override
  public String toString() {
    return "CacheOption{" + tables.toString() + "CacheConstraints: "+resultSetIdentifier.getConstraints().toString()+" OptionConstraints: "+constraints.toString()+" Site: " + site.toString() + '}';
  }

  /**
   *
   * @param alternativePlan - is ArrayList because of multiple fragments
   */
  public void addAlternativePlan(List<Option> alternativePlan) {
    this.alternativePlan = alternativePlan;
  }

  public ResultSetIdentifier getResultSetIdentifier() {
    return resultSetIdentifier;
  }

  @Override
  protected void attributesContained(Map<String, Boolean> contained) {
    for (Set<String> attributes : resultSetIdentifier.getAttributes().values())
      for (String attribute : attributes) {
        if (contained.containsKey(attribute))
          contained.put(attribute, true);
    }
  }
}
