package dascosa.site.test;

import dascosa.message.request.*;
import dascosa.site.MessageClient;
import dascosa.site.RequestResponseManager;
import dascosa.site.update.*;

import javax.sql.DataSource;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 09.nov.2007
 * Time: 15:57:33
 * To change this template use File | Settings | File Templates.
 */
public final class CommitTester implements MessageClient, CommitClient
{
  private final CommitManager commitManager;
  private final RequestResponseManager requestResponseManager;

  public CommitTester(RequestResponseManager requestResponseManager, CommitManager commitManager)
  {
    this.requestResponseManager = requestResponseManager;
    this.commitManager = commitManager;
  }

// --------------------- Begin Interface CommitClient ---------------------

  public void statementCompleted(CommitStatement statement, boolean comitted)
  {
    System.out.println(statement + " commit result: " + comitted);
  }

// --------------------- End Interface CommitClient ---------------------


// --------------------- Begin Interface MessageClient ---------------------

  public void responseReceived(AbstractResponseMsg msg, Object parameters[], DataSource dataSource)
  {
    if (msg instanceof LookupResponseMsg) {
      LookupResponseMsg message = (LookupResponseMsg)msg;
      CommitStatement commitStatement = (CommitStatement)parameters[0];
      commitManager.startCommitProcess(this, commitStatement, message.getSites(), message.getMasterIndex(), 
                                       message.getFragmentNumbers(), "TEST");
    }
  }

// --------------------- End Interface MessageClient ---------------------

  public void executeTest(int number)
  {
    if (number == 1) {
      String sql = "UPDATE TEST SET VALUE = 'UTROLIG'";
      CommitStatement test = new UpdateStatement(sql);
      requestResponseManager.sendRequest(new LookupRequestMsg("test"), "test", this, new Object[] {test});
    }
  }
}
