/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dascosa.site.test;



import dascosa.Dascosa;
import dascosa.message.TestCompleteMsg;
import dascosa.message.flood.AbstractFloodResponseMsg;
import dascosa.message.flood.TestRunnerRequestMsg;
import dascosa.message.flood.TestRunnerResponseMsg;
import dascosa.site.FloodClient;
import dascosa.site.NetworkLayer;
import dascosa.site.RequestResponseManager;
import dascosa.site.SiteManager;
import dascosa.site.TestListener;
import dascosa.util.FilteredOutput;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.ConcurrentSkipListSet;
import rice.p2p.commonapi.NodeHandle;

/**
 *
 * @author jan
 */
public class TestRunner implements TestListener, FloodClient {

  private final NetworkLayer networkLayer;
  private final SiteManager siteManager;
  private NodeHandle initiatingSite;

  public TestRunner(SiteManager siteManager, NetworkLayer networkLayer)
  {
    this.siteManager = siteManager;
    this.networkLayer = networkLayer;
  }

  public void receiveMessage(TestRunnerRequestMsg message) {
    //Dascosa.out.println(FilteredOutput.DEBUG, "DEBUG: Starting tests for " + siteManager.getLocalSite().toString());
    initiatingSite = message.getInitiatingSite();
    siteManager.addTestListener(this);
    siteManager.executeSQL(message.getCommand());
  }

  public void receiveMessage(TestCompleteMsg message) {
	  siteManager.decrementWaiting();
  }
  
  public void testComplete() {
    networkLayer.sendMessage(new TestCompleteMsg(siteManager.getLocalSite()), initiatingSite);
  }

  public void floodCompleted(Object[] parameter) {
    siteManager.fireDebugMessageEvent("Test runner initiated.\n");
  }

  public void responseReceived(AbstractFloodResponseMsg message, Object[] parameter) {
    TestRunnerResponseMsg msg = (TestRunnerResponseMsg) message;
    Dascosa.out.println(FilteredOutput.DEBUG, "TESTRUNNER: Response from " + msg.getSite());
  }

}