package dascosa.site.tpch;

import dascosa.algebra.*;
import dascosa.algebra.constraints.Constraint;
import dascosa.algebra.constraints.RegexConstraint;
import dascosa.algebra.function.Function;
import dascosa.algebra.function.CountFunction;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 12.jan.2009
 * Time: 13:45:26
 * To change this template use File | Settings | File Templates.
 */
public final class Q13
{
  public static final String DEFAULT_WORD1 = "special";
  public static final String DEFAULT_WORD2= "requests";
  public static final String[] WORDS1 = {"special", "pending", "unusual", "express"};
  public static final String[] WORDS2 = {"packages", "requests", "accounts", "deposits"};

  private Q13()
  {
  }

  /**
   *
   * @param displayNode
   * @param word1 Randomly selected from 4 possible values: special, pending, unusual, express. Default = special.
   * @param word2 Randomly selected from 4 possible values: packages, requests, accounts, deposits. Default = requests.
   */
  public static void makeQuery(AlgebraNode displayNode, String word1, String word2)
  {
    AlgebraNode orderNode = new OrderNode(displayNode, new String[] {"CUSTDIST", "C_COUNT"},
                                          new boolean[] {false, false});
    Function countFunction = new CountFunction("CUSTDIST");
    String[] attributes = {"C_COUNT"};
    AlgebraNode aggregateNode = new AggregateNode(orderNode, attributes, new Function[] {countFunction},
                                                  attributes);

    // Nested
    Function countFunction2 = new CountFunction("O_ORDERKEY", "C_COUNT");
    String[] attributes2 = {"C_CUSTKEY"};
    AlgebraNode aggregateNode2 = new AggregateNode(aggregateNode, attributes2, new Function[] {countFunction2},
                                                   attributes2);
    AlgebraNode joinNode = new OuterJoinNode(aggregateNode2, "C_CUSTKEY", "C_CUSTKEY", OuterJoinNode.TYPE_LEFT_OUTER);

    // Customer
    TpchTester.addFragmentScanNodes(joinNode, "customer", 5);

    // Orders
    Constraint ordersConstraint = new RegexConstraint("O_COMMENT", ".*" + word1 + ".*" + word2 + ".*", true, "%"+word1+"%"+word2+"%");
    AlgebraNode ordersConstraintNode = new ConstraintNode(joinNode, ordersConstraint);
    TpchTester.addFragmentScanNodes(ordersConstraintNode, "orders", 5);
  }

  /**
   * This query has not been optimized
   *
   * @param displayNode
   * @param word1 Randomly selected from 4 possible values: special, pending, unusual, express. Default = special.
   * @param word2 Randomly selected from 4 possible values: packages, requests, accounts, deposits. Default = requests.
   */
  public static void makeOptimizedQuery(AlgebraNode displayNode, String word1, String word2)
  {
    makeQuery(displayNode, word1, word2);
  }
}
