package dascosa.site.tpch;

import dascosa.algebra.*;
import dascosa.algebra.constraints.Constraint;
import dascosa.algebra.constraints.ComparableConstraint;
import dascosa.algebra.function.Function;
import dascosa.site.tpch.function.Q14Function1;

import java.util.Calendar;
import java.util.GregorianCalendar;
import java.sql.Date;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 12.jan.2009
 * Time: 13:46:09
 * To change this template use File | Settings | File Templates.
 */
public final class Q14
{
  public static final int DEFAULT_MONTH = 32;

  private Q14()
  {
  }

  /**
   *
   * @param displayNode
   * @param month Randomly selected within January 1993 (=0) and December 1997 (=59). Default = September 1995 (=32).
   */
  public static void makeQuery(AlgebraNode displayNode, int month)
  {
    int month2 = month + 1;
    int year = 1993 + month/12;
    int year2 = 1993 + month2/12;
    month = Calendar.JANUARY + (month % 12);
    month2 = Calendar.JANUARY + (month2 % 12);

    Function promoRevenue = new Q14Function1();
    AlgebraNode aggregateNode = new AggregateNode(displayNode, new String[0], new Function[] {promoRevenue},
                                                  new String[0]);
    AlgebraNode joinNode = new NaturalJoinNode(aggregateNode);

    // Lineitem
    Calendar calendar = new GregorianCalendar(year, month, 1);
    Date date1 = new Date(calendar.getTimeInMillis());
    calendar.set(year2, month2, 1);
    Date date2 = new Date(calendar.getTimeInMillis());
    Constraint lineitemConstraint1 = new ComparableConstraint("L_SHIPDATE", ">=", date1);
    Constraint lineitemConstraint2 = new ComparableConstraint("L_SHIPDATE", "<", date2);
    Constraint lineitemConstraints[] = new Constraint[] {lineitemConstraint1, lineitemConstraint2};
    AlgebraNode lineitemConstraintNode = new ConstraintNode(joinNode, lineitemConstraints);
    TpchTester.addFragmentScanNodes(lineitemConstraintNode, "lineitem", 5);

    // Part
    TpchTester.addFragmentScanNodes(joinNode, "part", 5);    
  }

  /**
   * This query has not been optimized.
   *
   * @param displayNode
   * @param month Randomly selected within January 1993 (=0) and December 1997 (=59). Default = September 1995 (=32).
   */
  public static void makeOptimizedQuery(AlgebraNode displayNode, int month)
  {
    makeQuery(displayNode, month);
  }
}
