package dascosa.site.tpch;

import dascosa.algebra.*;
import dascosa.algebra.constraints.*;
import dascosa.algebra.function.Function;
import dascosa.algebra.function.SumFunction;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 12.jan.2009
 * Time: 13:49:54
 * To change this template use File | Settings | File Templates.
 */
public final class Q18
{
  public static final int DEFAULT_QUANTITY = 300;

  private Q18()
  {
  }

  /**
   *
   * @param displayNode
   * @param quantity Randomly selected within [312, 315]. Default = 300 (sic!).
   */
  public static void makeQuery(AlgebraNode displayNode, int quantity)
  {
    AlgebraNode limitNode = new LimitNode(displayNode, 100);
    AlgebraNode orderNode = new OrderNode(limitNode, new String[] {"O_TOTALPRICE", "O_ORDERDATE"},
                                          new boolean[] {false, true});
    String attributes[] = new String[] {"C_NAME", "C_CUSTKEY", "O_ORDERKEY", "O_ORDERDATE", "O_TOTALPRICE"};
    Function sumFunction = new SumFunction("L_QUANTITY");
    AlgebraNode aggregateNode = new AggregateNode(orderNode, attributes, new Function[] {sumFunction}, attributes);
    AlgebraNode joinNode1 = new NaturalJoinNode(aggregateNode);
    AlgebraNode joinNode2 = new NaturalJoinNode(joinNode1);

    // Customer
    TpchTester.addFragmentScanNodes(joinNode1, "customer", 5);

    // Lineitem
    TpchTester.addFragmentScanNodes(joinNode2, "lineitem", 5);

    // Orders
    Constraint nestedConstraint = new NestedInConstraint("O_ORDERKEY", false);
    AlgebraNode nestedConstraintNode = new ConstraintNode(joinNode2, nestedConstraint);
    TpchTester.addFragmentScanNodes(nestedConstraintNode, "orders", 5);

    // Nested
    Constraint havingConstraint = new LongConstraint("SUM(L_QUANTITY)", ">", quantity);
    AlgebraNode havingConstraintNode = new ConstraintNode(nestedConstraintNode, havingConstraint);
    Function nestedFunction = new SumFunction("L_QUANTITY");
    String[] attributes2 = {"O_ORDERKEY"};
    AlgebraNode nestedAggregateNode = new AggregateNode(havingConstraintNode, attributes2,
                                                        new Function[] {nestedFunction}, attributes2);
    TpchTester.addFragmentScanNodes(nestedAggregateNode, "lineitem", 5);
  }

  /**
   * This query has not been optimized.
   *
   * @param displayNode
   * @param quantity Randomly selected within [312, 315]. Default = 300 (sic!).
   */
  public static void makeOptimizedQuery(AlgebraNode displayNode, int quantity)
  {
    makeQuery(displayNode, quantity);
  }
}
