package dascosa.site.tpch.function;

import dascosa.algebra.function.Function;
import dascosa.data.Operand;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 22.feb.2008
 * Time: 19:54:17
 * To change this template use File | Settings | File Templates.
 */
public final class Q11Function2 extends Function
{
  private transient int attributeColumn1;
  private transient int attributeColumn2;
  private final double fraction;

  public Q11Function2(double fraction)
  {
    super(null, "FRACSUM");
    this.fraction = fraction;
  }

  public void init(Operand operand)
  {
    attributeColumn1 = operand.getColumn("PS_SUPPLYCOST");
    if (attributeColumn1 == -1)
      System.err.println("Q11Function2: Unable to find PS_SUPPLYCOST");
    attributeColumn2 = operand.getColumn("PS_AVAILQTY");
    if (attributeColumn2 == -1)
      System.err.println("Q11Function2: Unable to find PS_AVAILQTY");
  }

  public Object processTuple(Object partialResult, Object[] tuple)
  {
    double value = ((Number)tuple[attributeColumn1]).doubleValue() * ((Number)tuple[attributeColumn2]).doubleValue() * fraction;
    if (partialResult != null)
      value += (Double)partialResult;
    return value;
  }
}
