package dascosa.site.tpch.function;

import dascosa.algebra.function.Function;
import dascosa.data.Operand;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 24.feb.2008
 * Time: 12:55:45
 * To change this template use File | Settings | File Templates.
 */
public final class Q14Function1 extends Function
{
  private transient int attributeColumn1;
  private transient int attributeColumn2;
  private transient int attributeColumn3;

  public Q14Function1()
  {
    super(null, "PROMO_REVENUE");
  }

  public void init(Operand operand)
  {
    attributeColumn1 = operand.getColumn("P_TYPE");
    if (attributeColumn1 == -1)
      System.err.println("Q14Function1: Unable to find P_TYPE");
    attributeColumn2 = operand.getColumn("L_EXTENDEDPRICE");
    if (attributeColumn2 == -1)
      System.err.println("Q14Function1: Unable to find L_EXTENDEDPRICE");
    attributeColumn3 = operand.getColumn("L_DISCOUNT");
    if (attributeColumn3 == -1)
      System.err.println("Q14Function1: Unable to find L_DISCOUNT");
  }

  public Object processPartialResult(Object partialResult)
  {
    Object[] objects = (Object[])partialResult;
    Double above = (Double)objects[0];
    Double below = (Double)objects[1];
    return 100 * above / below;
  }

  public Object processTuple(Object partialResult, Object[] tuple)
  {
    double above = 0;
    double below = ((Number)tuple[attributeColumn2]).doubleValue() *
                   (1 - ((Number)tuple[attributeColumn3]).doubleValue());
    String pType = (String)tuple[attributeColumn1];
    if (pType.startsWith("PROMO"))
      above = below;
    if (partialResult != null) {
      Object[] objects = (Object[])partialResult;
      above += (Double)objects[0];
      below += (Double)objects[1];
      objects[0] = above;
      objects[1] = below;
      return objects;
    }
    return new Object[] {above, below};
  }
}
