package dascosa.site.tpch.function;

import dascosa.algebra.function.Function;
import dascosa.data.Operand;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 24.feb.2008
 * Time: 13:25:43
 * To change this template use File | Settings | File Templates.
 */
public final class Q15Function1 extends Function
{
  private transient int attributeColumn1;
  private transient int attributeColumn2;

  public Q15Function1()
  {
    super(null, "TOTAL_REVENUE");
  }

  public void init(Operand operand)
  {
    attributeColumn1 = operand.getColumn("L_EXTENDEDPRICE");
    if (attributeColumn1 == -1)
      System.err.println("Q15Function1: Unable to find L_EXTENDEDPRICE");
    attributeColumn2 = operand.getColumn("L_DISCOUNT");
    if (attributeColumn2 == -1)
      System.err.println("Q15Function1: Unable to find L_DISCOUNT");
  }

  public Object processTuple(Object partialResult, Object[] tuple)
  {
    double value = ((Number)tuple[attributeColumn1]).doubleValue() * (1 - ((Number)tuple[attributeColumn2]).doubleValue());
    if (partialResult != null)
      value += (Double)partialResult;
    return value;
  }
}
