package dascosa.site.tpch.function;

import dascosa.algebra.function.Function;
import dascosa.data.Operand;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 22.feb.2008
 * Time: 12:12:26
 * To change this template use File | Settings | File Templates.
 */
public final class Q1Function2 extends Function
{
  private transient int attributeColumn1;
  private transient int attributeColumn2;
  private transient int attributeColumn3;

  public Q1Function2()
  {
    super(null, "SUM_CHARGE");
  }

  public void init(Operand operand)
  {
    attributeColumn1 = operand.getColumn("L_EXTENDEDPRICE");
    if (attributeColumn1 == -1)
      System.err.println("Q1Function2: Unable to find L_EXTENDEDPRICE");
    attributeColumn2 = operand.getColumn("L_DISCOUNT");
    if (attributeColumn2 == -1)
      System.err.println("Q1Function2: Unable to find L_DISCOUNT");
    attributeColumn3 = operand.getColumn("L_TAX");
    if (attributeColumn3 == -1)
      System.err.println("Q1Function2: Unable to find L_TAX");
  }

  public Object processTuple(Object partialResult, Object[] tuple)
  {
    double value = ((Number)tuple[attributeColumn1]).doubleValue() *
                   (1 - ((Number)tuple[attributeColumn2]).doubleValue()) *
                   (1 + ((Number)tuple[attributeColumn3]).doubleValue());
    if (partialResult != null)
      value += (Double)partialResult;
    return value;
  }
}
