package dascosa.site.tpch.function;

import dascosa.algebra.function.Function;
import dascosa.data.Operand;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 22.feb.2008
 * Time: 18:09:06
 * To change this template use File | Settings | File Templates.
 */
public final class Q8Function1 extends Function
{
  private transient int attributeColumn1;
  private transient int attributeColumn2;
  private final String nation;

  public Q8Function1(String nation)
  {
    super(null, "MKT_SHARE");
    this.nation = nation;
  }

  public void init(Operand operand)
  {
    attributeColumn1 = operand.getColumn("NATION");
    if (attributeColumn1 == -1)
      System.err.println("Q8Function1: Unable to find NATION");
    attributeColumn2 = operand.getColumn("VOLUME");
    if (attributeColumn2 == -1)
      System.err.println("Q8Function1: Unable to find VOLUME");
  }

  public Object processPartialResult(Object partialResult)
  {
    Object[] objects = (Object[])partialResult;
    Double above = (Double)objects[0];
    Double below = (Double)objects[1];
    return above / below;
  }

  public Object processTuple(Object partialResult, Object[] tuple)
  {
    double above = 0;
    double below = ((Number)tuple[attributeColumn2]).doubleValue();
    String nation = tuple[attributeColumn1].toString();
    if (nation.startsWith(this.nation))
      above = below;
    if (partialResult != null) {
      Object[] objects = (Object[])partialResult;
      above += (Double)objects[0];
      below += (Double)objects[1];
      objects[0] = above;
      objects[1] = below;
      return objects;
    }
    return new Object[] {above, below};
  }
}
