package dascosa.site.update;

import dascosa.message.request.*;
import dascosa.site.*;
import dascosa.site.localdb.LocalFragmentHandler;

import javax.sql.DataSource;
import java.sql.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 02.jul.2008
 * Time: 15:41:42
 * To change this template use File | Settings | File Templates.
 */
public final class CreateHandler implements MessageClient
{
  private final LocalFragmentHandler localFragmentHandler;
  private final RequestResponseManager requestResponseManager;
  private final SiteManager siteManager;

  public CreateHandler(SiteManager siteManager, LocalFragmentHandler localFragmentHandler,
                       RequestResponseManager requestResponseManager)
  {
    this.siteManager = siteManager;
    this.localFragmentHandler = localFragmentHandler;
    this.requestResponseManager = requestResponseManager;
  }

// --------------------- Begin Interface MessageClient ---------------------

  public void responseReceived(AbstractResponseMsg msg, Object parameters[], DataSource dataSource)
  {
    LookupResponseMsg message = (LookupResponseMsg)msg;
    if (message.getAttributeNames() != null || message.getSites() != null)
      siteManager.fireDebugErrorEvent("Error: Table already exists.\n");
    else {
      String sql = (String)parameters[0];
      try {
        Connection connection = dataSource.getConnection();
        Statement statement = connection.createStatement();
        statement.executeUpdate(sql);
        statement.close();
        connection.close();
        localFragmentHandler.initializeTableFragment(message.getTableName(), 1, dataSource);
      } catch (SQLException e) {
        siteManager.fireDebugErrorEvent(e.getMessage());
        e.printStackTrace();
      }
    }
  }

// --------------------- End Interface MessageClient ---------------------

  public void executeCreate(String sql)
  {
    int index = sql.indexOf('(');
    String tablename = sql.substring(13, index).trim();
    if (sql.endsWith(";"))
      sql = sql.substring(0, sql.length() - 1);
    sql = "create table " + tablename + "_1" + sql.substring(index);
    AbstractRequestMsg message = new LookupRequestMsg(tablename);
    requestResponseManager.sendRequest(message, tablename, this, new Object[] {sql});
  }
}
