package dascosa.site.update;

import java.sql.SQLException;
import java.sql.Statement;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 09.nov.2007
 * Time: 16:02:48
 * To change this template use File | Settings | File Templates.
 */
public final class UpdateStatement implements CommitStatement
{
  private final String sql;

  public UpdateStatement(String sql)
  {
    this.sql = sql;
  }

// --------------------- Begin Interface CommitStatement ---------------------

  public int executeStatement(String tableName, int fragmentNr, Statement statement) throws SQLException
  {
    String s = sql.toUpperCase();
    tableName = tableName.toUpperCase();
    s = s.replaceFirst("\\s" + tableName + "\\s", ' ' + tableName + '_' + fragmentNr + ' ');
    s = s.replaceFirst("\\s" + tableName + "\\(", ' ' + tableName + '_' + fragmentNr + '(');
    int rowsChanged = statement.executeUpdate(s);
    if (rowsChanged > 0)
      return STATEMENT_OK_CHANGED;
    return STATEMENT_OK_UNCHANGED;
  }

// --------------------- End Interface CommitStatement ---------------------

  public boolean equals(Object obj)
  {
    if (obj instanceof UpdateStatement)
      return sql.equals(((UpdateStatement)obj).sql);
    return false;
  }

  public int hashCode()
  {
    return sql.hashCode();
  }

  public String toString()
  {
    return sql;
  }
}
