package dascosa.util;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.List;

public final class FilteredOutput extends PrintStream {
	public static final int ALL = Integer.MAX_VALUE;
	public static final int NOTHING = 0;
	public static final int UNSPECIFIED = 2;
	public static final int OPTIMIZER = 4;
	public static final int LOCALDB = 8;
	public static final int DATA_STATISTICS = 16;
	public static final int TOTAL_TIME = 32;
	public static final int OPTIMIZER_TESTLOG = 64;
	public static final int PLANNING_TIME = 128;
	public static final int EXECUTION_TIME = 256;
	public static final int DEBUG = 512;
  public static final int CACHEINVESTMENT = 1024;
  public static final int CACHELOG = 2048;
  public static final int PACKETSIZE = 4096;

	private int mask;

	public FilteredOutput(int categoryMask, File file)
			throws FileNotFoundException {
		super(file);
    mask = categoryMask;
	}

	public FilteredOutput(int categoryMask) {
		super(System.out);
    mask = categoryMask;
	}

	@Override
	public void print(String string) {
		print(UNSPECIFIED, string);
	}

	public void print(int cat, String string) {
		if ((mask & cat) > 0)
			super.print(string);
	}

	@Override
	public void println(String string) {
		print(string + '\n');
	}

	public void println(int cat, String string) {
		print(cat, string + '\n');
	}

	public void println(int cat, List list) {
		if ((mask & cat) > 0)
			super.println(list);

	}
}
