package dascosa.util;

import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 11.mar.2008
 * Time: 19:39:59
 * To change this template use File | Settings | File Templates.
 */
public final class LogParser
{
  private static String getWord(String line, int wordnum)
  {
    StringTokenizer st = new StringTokenizer(line);
    String word = st.nextToken();
    while (st.hasMoreTokens() && wordnum != 0) {
      word = st.nextToken();
      wordnum--;
    }
    return word;
  }

  private static String readUntil(BufferedReader br, String line, String start) throws IOException
  {
    while (line != null && !line.startsWith(start))
      line = br.readLine();
    return line;
  }

  public static void main(String args[]) throws IOException
  {
    new LogParser(new File(args[0]));
  }

  private LogParser(File file) throws IOException
  {
    BufferedReader br = new BufferedReader(new FileReader(file));

    long querySum = 0;
    long crashSum = 0;
    int counter = 0;
    long minSum = Long.MAX_VALUE;
    long maxSum = Long.MIN_VALUE;
    long minCrash = Long.MAX_VALUE;
    long maxCrash = Long.MIN_VALUE;
    String line = br.readLine();
    while (line != null) {
      line = LogParser.readUntil(br, line, "Test starting");
      long startTime = Long.parseLong(LogParser.getWord(line, 2));

      line = LogParser.readUntil(br, line, "Crashing site");
      long crashTime = Long.parseLong(LogParser.getWord(line, 2));
      long crashDuration = crashTime - startTime;
      crashSum += crashDuration;
      minCrash = Math.min(crashDuration, minCrash);
      maxCrash = Math.max(crashDuration, maxCrash);

      line = LogParser.readUntil(br, line, "Query completed");
      long stopTime = Long.parseLong(LogParser.getWord(line, 2));
      long duration = stopTime - startTime;
      querySum += duration;
      minSum = Math.min(duration, minSum);
      maxSum = Math.max(duration, maxSum);

      System.out.println(duration);
      System.out.println(crashDuration + " - " + duration);

      counter++;
      line = br.readLine();
    }
    double averageCrash = (double)crashSum / counter;
    System.out.println("Average crashSum: " + averageCrash);
    System.out.println("MIN-MAX: " + (minCrash - averageCrash) + " : " + (maxCrash - averageCrash));
    double averageSum = (double)querySum / counter;
    System.out.println("Average time: " + averageSum);
    System.out.println("MIN-MAX: " + (minSum - averageSum) + " : " + (maxSum - averageSum));

//    String line = br.readLine(); // *** BIG TEST
//    while (line != null) {
//      int testSize = Integer.parseInt(getWord(line, 4));
//      double querySum = 0;
//      int counter = 0;
//      while (!line.startsWith("*** BIG TEST COMPLETED")) {
//        line = readUntil(br, line, "Test starting");
//        long startTime = Long.parseLong(getWord(line, 2));
//        line = readUntil(br, line, "Query completed");
//        long stopTime = Long.parseLong(getWord(line, 2));
//        System.out.println(testSize + " : " + (stopTime - startTime));
//        querySum += (stopTime - startTime);
//        counter++;
//        line = br.readLine();
//        while (line.startsWith("NPE"))
//          line = br.readLine();
//      }
//      System.out.println("Average: " + (querySum / counter));
//      line = br.readLine();
//    }
  }
}
