package dascosa.util;

import java.io.OutputStream;
import java.io.PrintStream;
import java.util.List;

public final class MultipleFilteredOutputs extends PrintStream{
	private final FilteredOutput[] outputs;
	public int counter;
  

  
	public MultipleFilteredOutputs(OutputStream out, FilteredOutput[] outputs){
    super(out);
    counter = 0;
		this.outputs = outputs;
	}

  @Override
	public void print(String string) {
		for (FilteredOutput f : outputs)
			f.print(FilteredOutput.UNSPECIFIED, counter+": "+ string);
		//counter++;
	}

	void print(int cat, String string) {
		for (FilteredOutput f : outputs)
			f.print(cat, counter+": "+ string);
		//counter++;
	}

	public void println(){
		print("\n");
	}
	public void println(Object o){
		print(o.toString()+ '\n');
	}
	public void println(String string) {
		print(string + '\n');
	}

	public void println(int cat, String string) {
		print(cat, string + '\n');
	}

	public void println(int cat, List list) {
		for (FilteredOutput f : outputs)
			f.println(cat, counter+": "+ list);

	}
}
