package dascosa.util;

import java.io.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 24.aug.2007
 * Time: 10:27:05
 * To change this template use File | Settings | File Templates.
 */
public final class TblParserNoFrag
{
  private static final String PATH = "/home/jan/NetBeansProjects/dascosa-git/dbgen";
  private static final double factor = 0.02;

  private final Table part =
    new Table("part",
              new String[] {"P_PARTKEY", "P_NAME", "P_MFGR", "P_BRAND", "P_TYPE", "P_SIZE", "P_CONTAINER", "P_RETAILPRICE", "P_COMMENT"},
              new String[] {"INT", "VARCHAR(55)", "CHAR(25)", "CHAR(10)", "VARCHAR(25)", "INT", "CHAR(10)", "DEC(9,2)", "VARCHAR(23)"},
              new String[] {"P_PARTKEY"}, (int)(200000 * factor / 1));

  private final Table supplier =
    new Table("supplier",
              new String[] {"S_SUPPKEY", "S_NAME", "S_ADDRESS", "N_NATIONKEY", "S_PHONE", "S_ACCTBAL", "S_COMMENT"},
              new String[] {"INT", "CHAR(25)", "VARCHAR(40)", "INT", "CHAR(15)", "DEC(9,2)", "VARCHAR(101)"},
              new String[] {"S_SUPPKEY"}, (int)(10000 * factor / 1));

  private final Table partsupp =
    new Table("partsupp",
              new String[] {"P_PARTKEY", "S_SUPPKEY", "PS_AVAILQTY", "PS_SUPPLYCOST", "PS_COMMENT"},
              new String[] {"INT", "INT", "INT", "DEC(9,2)", "VARCHAR(199)"},
              new String[] {"P_PARTKEY", "S_SUPPKEY"}, (int)(800000 * factor / 1));

  private final Table customer =
    new Table("customer",
              new String[] {"C_CUSTKEY", "C_NAME", "C_ADDRESS", "N_NATIONKEY", "C_PHONE", "C_ACCTBAL", "C_MKTSEGMENT", "C_COMMENT"},
              new String[] {"INT", "VARCHAR(25)", "VARCHAR(40)", "INT", "CHAR(15)", "DEC(9,2)", "CHAR(10)", "VARCHAR(117)"},
              new String[] {"C_CUSTKEY"}, (int)(150000 * factor / 1));

  private final Table orders =
    new Table("orders",
              new String[] {"O_ORDERKEY", "C_CUSTKEY", "O_ORDERSTATUS", "O_TOTALPRICE", "O_ORDERDATE", "O_ORDERPRIORITY", "O_CLERK", "O_SHIPPRIORITY", "O_COMMENT"},
              new String[] {"INT", "INT", "CHAR(1)", "DEC(9,2)", "DATE", "CHAR(15)", "CHAR(15)", "INT", "VARCHAR(79)"},
              new String[] {"O_ORDERKEY"}, (int)(1500000 * factor / 1));

  private final Table lineitem =
    new Table("lineitem",
              new String[] {"O_ORDERKEY", "P_PARTKEY", "S_SUPPKEY", "L_LINENUMBER", "L_QUANTITY", "L_EXTENDEDPRICE", "L_DISCOUNT", "L_TAX", "L_RETURNFLAG", "L_LINESTATUS", "L_SHIPDATE", "L_COMMITDATE", "L_RECEIPTDATE", "L_SHIPINSTRUCT", "L_SHIPMODE", "L_COMMENT"},
              new String[] {"INT", "INT", "INT", "INT", "DEC(9,2)", "DEC(9,2)", "DEC(9,2)", "DEC(9,2)", "CHAR(1)", "CHAR(1)", "DATE", "DATE", "DATE", "CHAR(25)", "CHAR(10)", "VARCHAR(44)"},
              new String[] {"O_ORDERKEY", "L_LINENUMBER"}, (int)(6050000 * factor / 1));

  private final Table nation =
    new Table("nation",
              new String[] {"N_NATIONKEY", "N_NAME", "R_REGIONKEY", "N_COMMENT"},
              new String[] {"INT", "CHAR(25)", "INT", "VARCHAR(152)"},
              new String[] {"N_NATIONKEY"});

  private final Table region =
    new Table("region",
              new String[] {"R_REGIONKEY", "R_NAME", "R_COMMENT"},
              new String[] {"INT", "CHAR(25)", "VARCHAR(152)"},
              new String[] {"R_REGIONKEY"});

  private final Site site = new Site(88, new Table[] {customer, part, partsupp, lineitem, orders, region, supplier, nation},
                                     new int[] {0, 0, 0, 0, 0, 0, 0, 0});
  private final Site site0 = new Site(0, new Table[] {customer},
                                      new int[] {1});
  private final Site site1 = new Site(1, new Table[] {part, nation},
                                      new int[] {1, 1});
  private final Site site2 = new Site(2, new Table[] {partsupp, region},
                                      new int[] {1});
  private final Site site3 = new Site(3, new Table[] {orders, supplier},
                                      new int[] {1, 1});
  private final Site site4 = new Site(4, new Table[] {lineitem},
                                      new int[] {1});
  private final Site site5 = new Site(5, new Table[] {customer},
                                      new int[] {1});
  private final Site site6 = new Site(6, new Table[] {part, nation},
                                      new int[] {1, 1});
  private final Site site7 = new Site(7, new Table[] {partsupp, region},
                                      new int[] {1});
  private final Site site8 = new Site(8, new Table[] {orders, supplier},
                                      new int[] {1, 1});
  private final Site site9 = new Site(9, new Table[] {lineitem},
                                      new int[] {1});

  private final Table tables[] = {part, supplier, partsupp, customer, orders, lineitem, nation, region};
  private final Site sites[] = {site0, site1, site2, site3, site4, site5, site6, site7, site8, site9};

  private static String parseLine(Table table, String line)
  {
    StringBuilder sb = new StringBuilder();
    int startIndex = 0;
    int endIndex = line.indexOf('|');
    int columnNumber = 0;
    while (endIndex != -1) {
      if (columnNumber > 0)
        sb.append(',');
      String s = line.substring(startIndex, endIndex);
      if (table.types[columnNumber].equals("INT") || table.types[columnNumber].startsWith("DEC"))
        sb.append(s);
      else
        sb.append('\"').append(s).append('\"');
      columnNumber++;
      startIndex = endIndex + 1;
      endIndex = line.indexOf('|', startIndex);
    }
    return sb.toString();
  }

  private static String writeSQL(Table table, String name)
  {
    StringBuilder sb = new StringBuilder();
    sb.append("DROP TABLE ").append(name).append(";\n");
    sb.append("CREATE TABLE ").append(name).append('(');
    for (int i = 0; i < table.columns.length; i++)
      sb.append(table.columns[i]).append(' ').append(table.types[i]).append(',');
    sb.append("PRIMARY KEY(");
    for (int i = 0; i < table.pks.length; i++) {
      if (i > 0)
        sb.append(',');
      sb.append(table.pks[i]);
    }
    sb.append("));\n");
    sb.append("CALL SYSCS_UTIL.SYSCS_IMPORT_TABLE(null,'").append(name.toUpperCase()).append("','").append(PATH).append(File.separatorChar).append(name).append(".del',null,null,null,0);\n");
    return sb.toString();
  }

  public static void main(String args[])
  {
    try {
      new TblParserNoFrag();
    } catch (IOException e) {
      e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
    }
  }

  private TblParserNoFrag() throws IOException
  {
    // Print tables
    for (Table table : tables) {
      long tupleCounter = 0;
      int partitionCounter = 1;
      String name = table.name + '_' + partitionCounter;
      BufferedReader br = new BufferedReader(new FileReader(table.name + ".tbl"));
      PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(name + ".del")));
      String line = br.readLine();
      while (line != null) {
        pw.println(TblParserNoFrag.parseLine(table, line));
        tupleCounter++;
        line = br.readLine();
        if (table.tuplesPerPartition > 0 && tupleCounter % table.tuplesPerPartition == 0) {
          pw.close();
          partitionCounter++;
          name = table.name + '_' + partitionCounter;
          pw = new PrintWriter(new BufferedWriter(new FileWriter(name + ".del")));
        }
      }
      pw.close();
      br.close();
    }

    // Print sites
    for (Site site : sites) {
      PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter("site" + site.siteNr + ".sql")));
      pw.println("CONNECT 'jdbc:derby:db" + site.siteNr + ";create=true';");
      for (int i = 0; i < site.tables.length; i++) {
        Table table = site.tables[i];
        String name = table.name + "_1";
        pw.println(TblParserNoFrag.writeSQL(table, name));
        pw.println();
      }
      pw.println("DISCONNECT;");
      pw.close();
    }
  }

// -------------------------- INNER CLASSES --------------------------

  private static final class Site
  {
    private final int siteNr;
    private final Table tables[];
    private final int partitions[];

    private Site(int siteNr, Table[] tables, int[] partitions)
    {
      this.siteNr = siteNr;
      this.tables = tables;
      this.partitions = partitions;
    }
  }

  private static final class Table
  {
    private final String name;
    private final String columns[];
    private final String types[];
    private final String pks[];
    private final int tuplesPerPartition;

    private Table(String name, String[] columns, String[] types, String pks[])
    {
      this.name = name;
      this.columns = columns;
      this.types = types;
      this.pks = pks;
      tuplesPerPartition = 0;
    }

    private Table(String name, String[] columns, String[] types, String pks[], int tuplesPerPartition)
    {
      this.name = name;
      this.columns = columns;
      this.types = types;
      this.pks = pks;
      this.tuplesPerPartition = tuplesPerPartition;
    }
  }
}
