package dascosa.util.fragsim;

import dascosa.util.fragsim.workload.Site;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 21.nov.2008
 * Time: 15:04:36
 * To change this template use File | Settings | File Templates.
 */
final class RefragmentSuggestion implements Comparable<RefragmentSuggestion>
{
  final Site site;
  final int startBucket;
  final int endBucket;
  private final double utility;

  RefragmentSuggestion(double utility, int startBucket, int endBucket, Site site)
  {
    this.utility = utility;
    this.startBucket = startBucket;
    this.endBucket = endBucket;
    this.site = site;
  }

// --------------------- Begin Interface Comparable ---------------------

  public int compareTo(RefragmentSuggestion o)
  {
    return Double.compare(o.utility, utility);
  }

// --------------------- End Interface Comparable ---------------------


  public String toString()
  {
    return "[" + startBucket + ',' + endBucket + "] => " + site;
  }

  boolean isCompatible(RefragmentSuggestion o)
  {
    if (o.startBucket >= startBucket && o.startBucket <= endBucket)
      return false;
    if (o.endBucket >= startBucket && o.endBucket <= endBucket)
      return false;
    if (startBucket >= o.startBucket && startBucket <= o.endBucket)
      return false;
    return !(endBucket >= o.startBucket && endBucket <= o.endBucket);
  }
}
