package dascosa.util.fragsim;

import dascosa.util.fragsim.workload.Site;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 08.okt.2008
 * Time: 13:49:14
 * To change this template use File | Settings | File Templates.
 */
final class Replicate
{
  private final AccessLogger accessLogger;
  private final Fragment fragment;
  private final boolean isMaster;
  private Site currentLocation;

  Replicate(Fragment fragment, Replicate replicate1, Replicate replicate2)
  {
    this.fragment = fragment;
    currentLocation = replicate1.getCurrentLocation();
    isMaster = false;
    accessLogger = new AccessLogger(this, Math.max(replicate1.getLogger().getBucketWidth(),
                                                   replicate2.getLogger().getBucketWidth()));
    accessLogger.combineLogs(replicate1.getLogger(), replicate2.getLogger());
  }

  Replicate(Fragment fragment, int bucketWidth, boolean isMaster)
  {
    this.fragment = fragment;
    this.isMaster = isMaster;
    accessLogger = new AccessLogger(this, bucketWidth);
  }

  public String toString()
  {
    return currentLocation.toString();
  }

  Site getCurrentLocation()
  {
    return currentLocation;
  }

  void setCurrentLocation(Site currentLocation)
  {
    this.currentLocation = currentLocation;
  }

  Fragment getFragment()
  {
    return fragment;
  }

  AccessLogger getLogger()
  {
    return accessLogger;
  }

  boolean isMaster()
  {
    return isMaster;
  }
}
