package dascosa.util.fragsim;

import dascosa.util.fragsim.workload.Site;
import dascosa.util.fragsim.workload.Workload;

import java.io.*;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 30.nov.2007
 * Time: 14:24:45
 * To change this template use File | Settings | File Templates.
 */
public final class TimeSimulator implements Simulator
{
  private final List<Fragment> fragments = new ArrayList<Fragment>();
  private final int[] messages = new int[AdaptiveAlgorithm.NUMBER_OF_COSTS];
  private AdaptiveAlgorithm fragAlgorithm;
  private Workload workload;

//  private static void testFragmentjoins()
//  {
//    Fragment fragment1 = new Fragment(0, 900);
//    Fragment fragment2 = new Fragment(1000, 1999);
//    long seed = System.currentTimeMillis();
//    Site site1 = new GeneralSite(1, null, 0, seed);
//    Site site2 = new GeneralSite(2, null, 0, seed);
//    Site site3 = new GeneralSite(3, null, 0, seed);
//    fragment1.addReplicate(site2);
//    fragment2.addReplicate(site3);
//    fragment1.recordAccess(site1, 500, true);
//    fragment1.recordAccess(site1, 501, true);
//    fragment2.recordAccess(site1, 1500, true);
//    fragment2.recordAccess(site1, 1501, true);
//    fragment2.recordAccess(site1, 1502, true);
//
//    int messages[] = new int[AdaptiveAlgorithm.NUMBER_OF_COSTS];
//    Fragment fragment = new Fragment(fragment1, fragment2, messages);
//  }

  public static void main(String args[]) throws IOException
  {
    if (args.length == 1)
      new TimeSimulator(new File(args[0]));
    else
      new TimeSimulator();
  }

  private TimeSimulator()
  {
//    for (double wLOp = 0.2; wLOp < 1.1; wLOp += 0.2)
//      for (double wFS = 0.25; wFS < 1.1; wFS += 0.25)
//        executeGeneralTest(20, 100000, wLOp, wFS, System.currentTimeMillis());
//    for (double wLOp = 0.2; wLOp < 1.1; wLOp += 0.2)
//      for (double wFS = 0.25; wFS < 1.1; wFS += 0.25)
//        executeSimulatorTest(20, 100000, wLOp, wFS, System.currentTimeMillis());

//    executeSimulatorTest(20, 100000, 0.1, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.2, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.3, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.4, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.5, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.6, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.7, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.8, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.9, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 1.0, 0.25, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.1, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.2, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.3, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.4, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.5, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.6, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.7, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.8, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.9, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 1.0, 0.5, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.1, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.2, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.3, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.4, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.5, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.6, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.7, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.8, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.9, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 1.0, 0.75, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.1, 1.0, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.2, 1.0, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.3, 1.0, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.4, 1.0, System.currentTimeMillis());
//    executeSimulatorTest(20, 100000, 0.5, 1.0, System.currentTimeMillis());
    executeSimulatorTest(20, 100000, 0.6, 1.0, System.currentTimeMillis());
    executeSimulatorTest(20, 100000, 0.7, 1.0, System.currentTimeMillis());
    executeSimulatorTest(20, 100000, 0.8, 1.0, System.currentTimeMillis());
    executeSimulatorTest(20, 100000, 0.9, 1.0, System.currentTimeMillis());
    executeSimulatorTest(20, 100000, 1.0, 1.0, System.currentTimeMillis());


//    executeGeneralTest(10, 100000, 1.0, 0.5, seed);
//    executeGeneralTest(10, 100000, 1.1, 0.5, seed);
//    executeGeneralTest(10, 100000, 1.2, 0.5, seed);
//    executeGeneralTest(10, 100000, 1.3, 0.5, seed);
//    executeGeneralTest(10, 100000, 1.4, 0.5, seed);
//    executeGeneralTest(10, 100000, 1.5, 0.5, seed);
//    executeGeneralTest(10, 100000, 1.5, 0.5, seed);
//    executeSimulatorTest(10, 100000, 1.0, 0.5);
//    executeSimulatorTest(10, 100000, 1.1, 0.5);
//    executeSimulatorTest(10, 100000, 1.2, 0.5);
//    executeSimulatorTest(10, 100000, 1.3, 0.5);
//    executeSimulatorTest(10, 100000, 1.4, 0.5);
//    executeSimulatorTest(10, 100000, 1.5, 0.5);
//    testFragmentjoins();
//    executeTestSerie(50000, 1.0, 0.5);
//    executeTest(3, 25000, 1.0, 0.5);
  }

  private TimeSimulator(File file) throws IOException
  {
    BufferedReader br = new BufferedReader(new FileReader(file));
    String line = br.readLine();
    while (line != null) {
      if (!line.startsWith(";") && line.length() > 0) {
        StringTokenizer st = new StringTokenizer(line);
        int operations = Integer.parseInt(st.nextToken());
        double wLOp = Double.parseDouble(st.nextToken());
        double wFS = Double.parseDouble(st.nextToken());
        executeTestSerie(operations, wLOp, wFS, System.currentTimeMillis());
      }
      line = br.readLine();
    }
    br.close();
  }

// --------------------- Begin Interface Simulator ---------------------

  public synchronized void accessTable(Site site, int id, boolean isWrite)
  {
    Fragment fragment = getResponsibleFragment(id);
    Replicate replicate = fragment.recordAccess(site, id, isWrite);
    int msgs[] = fragAlgorithm.computeCost(replicate, site, isWrite);
    workload.operationDone();
    for (int i = 0; i < msgs.length; i++)
      messages[i] += msgs[i];
  }

  public synchronized void joinLocalMasterReplicas(int messages[])
  {
    boolean hasJoined = true;
    while (hasJoined) {
      hasJoined = false;
      for (int i = 0; !hasJoined && i < fragments.size() - 1; i++) {
        Fragment fragment1 = fragments.get(i);
        Replicate masterReplica1 = fragment1.getMasterReplica();
        for (int j = i + 1; !hasJoined && j < fragments.size(); j++) {
          Fragment fragment2 = fragments.get(j);
          Replicate masterReplica2 = fragment2.getMasterReplica();
          long minMax = Math.min(fragment1.getMaxAssigned(), fragment2.getMaxAssigned());
          long maxMin = Math.max(fragment1.getMinAssigned(), fragment2.getMinAssigned());
          if (minMax + 1 == maxMin && (masterReplica1.getCurrentLocation() == masterReplica2.getCurrentLocation() ||
                  masterReplica1.getCurrentLocation() == null ||
                  masterReplica2.getCurrentLocation() == null)) {
            if (masterReplica1.getCurrentLocation() == null)
              masterReplica1.setCurrentLocation(masterReplica2.getCurrentLocation());
            else if (masterReplica2.getCurrentLocation() == null)
              masterReplica2.setCurrentLocation(masterReplica1.getCurrentLocation());
            Fragment joinedFragment = new Fragment(fragment1, fragment2, messages);
            fragments.remove(fragment1);
            fragments.remove(fragment2);
            fragments.add(joinedFragment);
            hasJoined = true;
            if (DEBUG)
              System.out.println("Join: " + fragment1 + " + " + fragment2 + " = " + joinedFragment);
          }
        }
      }
    }
  }

  public synchronized void splitFragment(Fragment oldFragment, Fragment newFragments[], int messages[])
  {
    fragments.remove(oldFragment);
    fragments.addAll(Arrays.asList(newFragments));
  }

// --------------------- End Interface Simulator ---------------------

  public String toString()
  {
    return messages[AdaptiveAlgorithm.REMOTE_WRITE] + " " +
            messages[AdaptiveAlgorithm.REMOTE_READ] + ' ' +
            messages[AdaptiveAlgorithm.REMOTE_UPDATE] + ' ' +
            messages[AdaptiveAlgorithm.MIGRATE_FRAGMENT] + ' ' +
            fragments.size() + ' ' +
            messages[AdaptiveAlgorithm.MIGRATE_TUPLES];
  }

  private void executeGeneralTest(int numberOfSites, int operationsPerSite, double wLOp, double wFS,
                                  long seed)
  {
    System.out.println("wLOp = " + wLOp + " wFS = " + wFS);
    fragAlgorithm = new AdaptiveAlgorithm(this, wLOp, wFS);
    Arrays.fill(messages, 0);
    fragments.clear();
    fragments.add(new Fragment(0, Integer.MAX_VALUE));
    workload = Workload.makeGeneralWorkload(this, numberOfSites, operationsPerSite, seed);
    workload.startRun();
    System.out.println("GeneralTest " + numberOfSites + ',' + operationsPerSite);
    System.out.println(this);
    Collections.sort(fragments);
    System.out.println(fragments);
  }

  private void executeSimulatorTest(int numberOfSites, int operationsPerSite, double wLOp, double wFS,
                                    long seed)
  {
    System.out.println("wLOp = " + wLOp + " wFS = " + wFS);
    fragAlgorithm = new AdaptiveAlgorithm(this, wLOp, wFS);
    Arrays.fill(messages, 0);
    fragments.clear();
    fragments.add(new Fragment(0, Integer.MAX_VALUE));
    workload = Workload.makeSimulatorWorkload(this, numberOfSites, operationsPerSite, seed);
    workload.startRun();
    System.out.println("SimulatorTest " + numberOfSites + ',' + operationsPerSite);
    System.out.println(this);
    Collections.sort(fragments);
    System.out.println(fragments);
  }

  private void executeTest(int number, int operations, double wLOp, double wFS, long seed)
  {
    fragAlgorithm = new AdaptiveAlgorithm(this, wLOp, wFS);
    Arrays.fill(messages, 0);
    fragments.clear();
    fragments.add(new Fragment(0, Integer.MAX_VALUE));
    workload = Workload.makeWorkload(this, number, operations, seed);
    workload.startRun();
    System.out.println(number + " " + this);
    Collections.sort(fragments);
    System.out.println(fragments);
  }

  private void executeTestSerie(int operations, double wLOp, double wFS, long seed)
  {
    System.out.println("wLOp = " + wLOp + " wFS = " + wFS);
    for (int i = 1; i <= Workload.NUM_TESTCASES; i++)
      executeTest(i, operations, wLOp, wFS, seed);
    System.out.println();
  }

  private Fragment getResponsibleFragment(int id)
  {
    for (Fragment fragment : fragments)
      if (fragment.isResponsible(id))
        return fragment;
    System.err.println("Unable to find fragment for: " + id);
    System.err.println(fragments);
    return null;
  }
}
