package dascosa.util.fragsim.logreader;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 05.mai.2008
 * Time: 16:05:52
 * To change this template use File | Settings | File Templates.
 */
final class TestResult implements Comparable<TestResult>
{
  static final int STATCOUNT = 6;
  final int testCase;
  private final int remoteWrite;
  private final int remoteRead;
  private final int remoteUpdate;
  private final int migrations;
  private final int fragments;
  private final int tuples;

  TestResult(int testCase, int remoteWrite, int remoteRead, int remoteUpdate,
             int migrations, int fragments, int tuples)
  {
    this.testCase = testCase;
    this.remoteWrite = remoteWrite;
    this.remoteRead = remoteRead;
    this.remoteUpdate = remoteUpdate;
    this.migrations = migrations;
    this.fragments = fragments;
    this.tuples = tuples;
  }

// --------------------- Begin Interface Comparable ---------------------

  public int compareTo(TestResult o)
  {
    return testCase - o.testCase;
  }

// --------------------- End Interface Comparable ---------------------

  public String toString()
  {
    return testCase + " " + remoteWrite + ' ' + remoteRead + ' ' + remoteUpdate + ' ' +
           migrations + ' ' + fragments + ' ' + tuples;
  }

  int getStat(int number)
  {
    switch (number) {
      case 0:
        return remoteWrite;
      case 1:
        return remoteRead;
      case 2:
        return remoteUpdate;
      case 3:
        return migrations;
      case 4:
        return fragments;
      case 5:
        return tuples;
    }
    return -1;
  }
}
