package dascosa.util.fragsim.workload;

import dascosa.util.fragsim.Simulator;

/**
 * Created by IntelliJ IDEA.
 * User: joh
 * Date: 30.nov.2007
 * Time: 14:46:00
 * To change this template use File | Settings | File Templates.
 */
public abstract class Site implements Runnable
{
  final Event event = new Event();
  private final Simulator index;
  private final int id;
  long clock;

  protected Site(int id, Simulator index)
  {
    this.id = id;
    this.index = index;
  }

// --------------------- Begin Interface Runnable ---------------------

  public void run()
  {
    while (!isDone()) {
      try {
        Thread.sleep(getNextDelay());
        boolean write = isWrite();
        index.accessTable(this, getNextValue(), write);
      } catch (InterruptedException e) {
        e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
      }
    }
  }

// --------------------- End Interface Runnable ---------------------

  public String toString()
  {
    return "Site " + id;
  }

  abstract long getNextDelay();

  /** Only method used by EventSimulator */
  public abstract Event getNextEvent();

  abstract int getNextValue();

  abstract boolean isDone();

  abstract boolean isWrite();
}
